' PACGUY by JOHN HESS
' Just eat the dots(you know the routine)
' Has interesting little tanks as the ghost
' You are the steamroller
' Just use the Keypad to move around
' USE THE SPACEBAR TO SHOOT

'THIS IS REGISTERED!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

' My homepage is: www.geocities.com\SiliconValley\Park\6074
' My email address is: jameshes@seidata.com

' DONT FORGET TO TRY JEWEL HUNTER and BLACK SUN...they are both at my
'homepage

'PLEASE SEND ANY COMMENTS OR ADVICE TO ME AS SOON AS POSSIBLE!
'Thanks!

DECLARE SUB beatgame (letter!())
DECLARE SUB keyboard (pacx!, pacy!, way!, newway!, key$, points!)
DECLARE SUB smooth (startx!, starty!, amount!)
DECLARE SUB uppermap ()
DECLARE SUB loadmap (map$(), marker!, letter!(), ballx!(), bally!(), ballway!(), ballcount!(), ballxold!(), ballyold!(), pacx!, pacy!, pacxold!, pacyold!)
DECLARE SUB shoots ()
DECLARE SUB lives ()
DECLARE SUB grabimage ()
DECLARE SUB trans (flag!, c!)
DECLARE SUB checkmap (pacx!, pacy!, way!, ballx!(), bally!(), ballxold!(), ballyold!(), ballcount!(), ballway!(), points!, finish!, value!(), rotateindex!)
DECLARE SUB winner (letter!())
DECLARE SUB ending (letter!())
DECLARE SUB kbhit ()
DECLARE SUB printg (sentence$, x!, y!, scale!, c!, flagshade!, letter!())
DECLARE SUB drawpac (pacx!, pacy!, way!)
DECLARE SUB erasemonsters (ballx!(), bally!(), ballxold!(), ballyold!())
DECLARE SUB drawmonsters (ballx!(), bally!(), ballway!())
DECLARE SUB iniget (ballx!(), bally!())
DECLARE SUB opening (letter!(), value!())
DECLARE SUB movemonsters (ballx!(), bally!(), ballway!(), ballcount!())
DECLARE SUB iniball (ballx!(), bally!(), ballxold!(), ballyold!(), ballway!(), ballcount!())
DECLARE SUB rotatecolor (rotateindex!, value!())
DECLARE SUB erasepac (pacxold!, pacyold!)
DECLARE SUB movepac (pacx!, pacy!, way!)
DECLARE SUB makepalette (value!())
DECLARE SUB iniletter (letter!())
DECLARE SUB died (pacx!, pacy!, value!())
DECLARE SUB makecolors (value!())
REM John Hess
REM Game Project
REM UTIMATE PACGUY PLUS++

REM ***Variable Description***
REM value() = array that holds the colors
REM letter() = array that holds the fonts
REM map() = array that holds the objects in the map
REM ballx() = x coordinate in the tanks
REM bally() = y coordinate in the tanks
REM ballway() = direction of tanks
REM ballcount() = decision loop of tanks
REM ballxold() = holds old x coordinates for tanks
REM ballyold() = holds old y coordinates for tanks
REM pac1() = hold graphics for pacguy in direction 1
REM pac2() = hold graphics for pacguy in direction 2
REM pac3() = hold graphics for pacguy in direction 3
REM pac4() = hold graphics for pacguy in direction 4
REM tank1() = holds graphics for tanks in direction 1
REM tank2() = holds graphics for tanks in direction 2
REM tank3() = holds graphics for tanks in direction 3
REM tank4() = holds graphics for tanks in direction 4
REM background1() = holds the background under tank 1
REM background2() = holds the background under tank 2
REM background3() = holds the background under tank 3
REM background4() = holds the background under tank 4
REM wid = constant(don't ever change this) width of pacguy
REM backcolor = color of boundaries
REM markercolor = color of markers(dots)
REM way = direction of pacguy
REM pacx = x coordinate of pacguy
REM pacy = y coordinate of pacguy
REM pacxold = holds old x coordinate for pacguy
REM pacyold = holds old y coordinate for pacguy
REM finish = amount of lives
REM marker = amount of markers
REM lcv = loop control variable
REM points = amount of markers gotten already
REM rotateindex = index for rotate color sub
REM c = color
REM radius = radius of explosion
REM cirbackground() = background under explosion
REM **************************

REM ***Sub Description***
REM grabimage() = grabs images for the game
REM iniball() = sets the starting values for the tanks
REM makecolors() = makes the colors for the palette
REM makepalette() = makes the 60 shades of primary colors palette
REM iniletter() = gets the fonts
REM opening() = opening screen
REM loadmap() = loads the map
REM iniget() = gets the beginning backgrounds for tanks
REM lives() = puts the lives at the top of the screen
REM keyboard() = gets the keyboard strokes
REM winner() = winning screen
REM ending() = ending of game after 3 lives have been lost
REM kbhit() = waits for a keystroke
REM printg() = displays graphical letters
REM drawpac() = draws pacguy
REM erasemonsters() = erases the tanks
REM drawmonsters() = draws the tanks
REM checkmap() = checks for boundary colors
REM movemonsters() = moves the tanks
REM rotatecolor() rotates the colors
REM erasepac() = erases pacguy
REM died() = when the player dies

REM ***************************



REM COLOR number = 65536 * blue + 256 * green + red
REM equation used to create palette

    COMMON SHARED homex
    COMMON SHARED homey

    COMMON SHARED nosteel


    COMMON SHARED maxmonster

    COMMON SHARED canigo

    COMMON SHARED shot
    COMMON SHARED startpacx
    COMMON SHARED startpacy

    COMMON SHARED shotway

    COMMON SHARED shotx
    COMMON SHARED shoty
    COMMON SHARED shotxold
    COMMON SHARED shotyold

    COMMON SHARED level


main:

REM clear all variables

    CLEAR

REM screen mode 13
REM (320/200 with 256 colors)
   
    SCREEN 13

REM arrays

    DIM value(0 TO 300):         'colors

    DIM letter(0 TO 6080):       'fonts
   
    DIM map$(0 TO 50, 0 TO 50):   'map

    DIM ballx(0 TO 20):          'x coordinate of tanks
   
    DIM bally(0 TO 20):          'y coordinate of tanks
   
    DIM ballway(0 TO 20):        'way for tanks
   
    DIM ballcount(0 TO 20):      'decides when to check for a turn

    DIM ballxold(0 TO 20):       'holds old x coordinates
   
    DIM ballyold(0 TO 20):       'holds old y coordinates

REM pacguy graphics

    DIM SHARED pac1(0 TO 50)
    DIM SHARED pac2(0 TO 50)
    DIM SHARED pac3(0 TO 50)
    DIM SHARED pac4(0 TO 50)
    DIM SHARED shotimage(0 TO 7)

REM tank graphics

    DIM SHARED tank1(0 TO 50)
    DIM SHARED tank2(0 TO 50)
    DIM SHARED tank3(0 TO 50)
    DIM SHARED tank4(0 TO 50)

REM array that hold the background of the tanks

    DIM SHARED background(2000)

    DIM SHARED steelx(0 TO 20)
    DIM SHARED steely(0 TO 20)

REM constants

    CONST wid = 5:             'width of pacguy(never change this)

    CONST backcolor = 150:     'only change this if you also change color of the block
   
    CONST backcolor2 = 140:    'second backcolor

    CONST markercolor = 240:   'color of the markers(dots)

REM ini variables

    way = 0:            'stops pacguy to begin with

    finish = 2:         'gives you three lives

    points = 0:         'amount of points

    level = 1:          'level
   
REM grab all of the sprites
   
    CALL grabimage

REM make the colors
   
    CALL makecolors(value())
           
REM put the colors into the registers

    CALL makepalette(value())

REM read in the fonts

    CALL iniletter(letter())

REM opening screen

    CALL opening(letter(), value())

REM load the map
   
    CLS

    RANDOMIZE (TIMER)

    

CLS

    CALL loadmap(map$(), marker, letter(), ballx(), bally(), ballway(), ballcount(), ballxold(), ballyold(), pacx, pacy, pacxold, pacyold)

REM get the background under the tanks

'    CALL iniget(ballx(), bally())

REM paste the lives at the top of the screen
   
    CALL lives

REM do until user wants to quit

    DO WHILE finish >= 0

REM grab keystrokes and store in newway if it is acceptable

        CALL keyboard(pacx, pacy, way, newway, key$, points)

REM move all of the tanks

        CALL movemonsters(ballx(), bally(), ballway(), ballcount())

REM move pacguy

        CALL movepac(pacx, pacy, way)

        IF shot = 1 THEN CALL shoots

REM check map for boundaries

        CALL checkmap(pacx, pacy, way, ballx(), bally(), ballxold(), ballyold(), ballcount(), ballway(), points, finish, value(), rotateindex)

REM erase the tanks with old background

        CALL erasemonsters(ballx(), bally(), ballxold(), ballyold())

REM draw the tanks according to ballway

        CALL drawmonsters(ballx(), bally(), ballway())
   
REM erase pacguy

        CALL erasepac(pacxold, pacyold)

REM draw pacguy according to way

        CALL drawpac(pacx, pacy, way)

        CALL uppermap

REM rotate colors (1-4 , 191-194)

        CALL rotatecolor(rotateindex, value())

REM store variables involved in animation into old variables
REM (produces flicker free or almost flicker free images)
REM (without using pages and only 16 colors)
  

        pacxold = pacx

        pacyold = pacy

        FOR lcv = 1 TO maxmonster

            ballxold(lcv) = ballx(lcv)

            ballyold(lcv) = bally(lcv)

        NEXT lcv


REM check to see if they won

        IF points >= marker THEN

            CALL winner(letter())
           
            CLS
           
            CALL loadmap(map$(), marker, letter(), ballx(), bally(), ballway(), ballcount(), ballxold(), ballyold(), pacx, pacy, pacxold, pacyold)

            CALL lives

            newway = 0:            'stops pacguy to begin with

            way = 0

            pacxold = pacx:     'puts variables into old ones

            pacyold = pacy
  
            finish = 2:         'gives you three lives

            points = 0:         'amount of points

        END IF

REM while running the game if the user hit q then it return to the main menu

        IF UCASE$(key$) = "Q" THEN

            CALL ending(letter())

            GOTO main

        END IF

    LOOP

REM display ending after 3 lives have been used

    CALL ending(letter())
                    
REM return to beginning of program

GOTO main

REM font data (and there is a lot of it)
REM (80 in each line)
REM (0's represent off pixels)
REM (1's represent on pixels)
REM (generated off of the system fonts)
REM * A good idea would be RLE(run length encoding) *

REM map data is beneath the font data

DATA 0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,0,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,0,0,0,0,0,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,0,1,1,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,1,1,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,1,0,0,0,0,1,1,0,1,1,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,1,1,0,1,1,0,1,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,1,0,0,1,1,0,0,0,1,1,0,1,1,0,0,1,1,1,0,1,1,0,1,1,1,1,0,1,1,1,1,0,1,1,0,1,1,1,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,1,1,1,0,0,0,0,1,1,1,1,0,0,0,1,1,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0
DATA 1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,1,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,1,1,1,0,0,1,1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0
DATA 0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,1,0,0,1,1,0,0,0,1,1,0,1,1,0,1,1,1,1,0,1,1,0,1,1,1,1,0,1,1,0,1,1,1,1,0,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,1,1,0,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,1,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,1,1,0,0,0,1,1,1,1,0,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,1,1,0,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,0,1,1,0,1,1,1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,1,1,0,1,0,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,0,1,1,0,1,1,1,0,0,1,1,0,1,1,1,1,0,1,1,0,1,1,0,1,1,1,1,0,1,1,0,0,1,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,1,0,0,0,0,1,1,0,1,1,0,0,1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,1,1,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,1,1,0,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,1,1,0,1,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,0,1,1,1,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,1,1,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,0,1,1,0,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,1,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,0,1,1,0,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1
DATA 0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0
DATA 1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,1,0,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0
DATA 1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,1,1,0,0,0,1,1,1,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0
DATA 1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,0,1,1,0,0,0,1,1,1,1,0,0,0,0,1,1,0,1,1,0,0,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,1,1,0,1,0,1,1,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,0,0,0,1,1,1,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,0,1,1,0,1,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,0,0,1,1,0,1,1,0,0,0,0,1,1,1,0,0,0,0,1,1,0,1,1,0,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0
DATA 1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,1,1,1,0,1,1,0,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,0,1,1,0,0,1,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0




REM map data
REM (0 markers\dots)
REM (1 regular red block)
REM (2 walk thru block)
REM (3 flashing green block)
REM (4 rotating grey blocks)
REM (5 rotating green blocks)
REM (9 blank blocks)
REM anything else is sent to printg
REM and put on as a character in gfx mode

REM Level 1 

DATA g,g,g,g,g,g,g,g,3,g,g,3,3,1,1,1,1,1,3,g,g,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,3,3,3,3,9,9,0,0,9,9,3,3,3,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,3,g,g,3,9,9,0,0,9,9,3,g,g,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,3,g,g,3,0,0,0,0,0,0,3,g,g,3,g,g,1,1,1,g,g,g
DATA g,g,g,g,g,g,g,g,3,3,3,0,0,0,0,0,0,0,0,3,3,3,g,g,1,g,1,g,g,g
DATA g,1,1,1,1,1,g,g,3,g,g,3,9,9,9,9,9,9,3,g,g,3,g,g,1,1,1,g,g,g
DATA g,1,g,g,g,1,g,g,3,g,g,4,1,s,s,s,s,1,4,g,g,3,g,g,g,g,g,g,g,g
DATA g,1,1,1,1,1,g,g,3,3,3,4,1,s,s,s,s,1,4,3,3,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,3,4,1,1,1,9,9,9,9,1,1,1,4,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,3,1,M,0,0,0,0,0,0,0,0,M,1,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,3,1,0,0,0,0,0,0,0,0,0,0,1,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,4,3,4,1,1,0,0,0,0,0,0,1,1,4,3,4,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,4,4,3,3,3,3,1,9,0,0,9,1,3,3,3,3,4,4,g,g,g,g,g,g
DATA w,w,w,w,w,w,w,w,w,w,w,w,3,1,0,0,1,3,w,w,w,w,w,w,w,w,w,w,w,w
DATA w,w,w,w,w,w,w,w,w,w,w,w,3,1,0,0,1,3,w,w,w,w,w,w,w,w,w,w,w,w
DATA w,w,w,w,w,w,w,w,w,w,w,w,3,1,0,0,1,3,w,w,w,w,w,w,w,w,w,w,w,w
DATA g,g,g,g,g,g,4,4,3,g,g,3,1,9,P,H,9,1,3,g,g,3,4,4,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,4,3,g,4,1,1,1,1,1,1,1,1,4,g,3,4,g,g,g,g,g,g,g

'Level 2

DATA g,1,1,1,g,g,w,w,w,w,w,w,w,w,w,w,w,w,g,g,1,1,1,1,g,g,w,w,w,w
DATA 1,0,0,0,1,g,g,w,w,w,w,w,w,w,w,w,1,1,1,1,0,0,0,0,1,g,w,w,w,w
DATA g,1,0,0,1,1,1,1,w,w,w,w,w,w,w,1,0,0,0,0,0,0,0,0,1,g,g,w,w,w
DATA g,1,1,0,0,0,0,0,1,1,1,1,1,1,1,9,0,0,0,0,0,0,0,0,1,g,g,w,w,w
DATA g,1,0,0,1,1,1,0,9,9,2,9,9,2,9,9,0,1,1,1,0,0,0,0,1,g,g,w,w,w
DATA 1,0,0,1,w,w,1,0,0,0,2,h,s,2,0,0,0,1,g,g,1,0,0,m,1,g,w,w,w,w
DATA 1,0,1,w,w,w,w,1,9,9,2,s,9,2,9,9,1,w,w,g,1,2,2,1,g,g,w,w,w,w
DATA 1,0,1,w,w,w,w,w,1,1,4,4,4,4,1,1,w,w,w,w,1,0,9,1,g,w,w,w,w,w
DATA 1,0,1,w,g,g,g,g,g,w,w,w,w,w,w,w,w,w,w,w,1,0,9,1,w,w,w,w,w,w
DATA 1,0,1,w,g,1,1,1,1,1,w,w,3,3,3,w,w,4,4,4,1,0,9,1,4,4,4,w,w,w
DATA 1,0,1,g,g,1,m,0,0,1,1,1,1,9,1,1,w,4,w,w,1,0,9,1,w,w,4,w,w,w
DATA 1,0,1,g,g,1,0,0,0,0,0,m,0,0,0,1,w,4,w,3,9,9,9,9,3,w,4,w,w,w
DATA 1,0,1,g,g,1,1,1,0,1,1,1,1,1,0,1,w,4,w,3,9,0,0,9,3,w,4,w,w,w
DATA 1,0,1,g,g,g,g,1,0,1,w,w,w,1,0,1,g,4,w,3,9,9,m,9,3,w,4,w,w,w
DATA 1,0,1,1,g,g,g,1,0,1,w,g,g,1,0,1,g,g,w,3,3,3,3,3,3,w,4,g,w,w
DATA 1,s,s,1,1,1,1,1,s,1,w,g,1,9,p,9,1,g,w,w,w,w,w,w,w,w,4,g,w,w
DATA 1,m,s,0,0,0,0,s,0,1,w,g,1,1,1,1,1,g,4,4,4,4,4,4,4,4,4,g,g,g
DATA 1,1,1,1,1,1,1,1,1,1,w,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g

'level 3

DATA 4,4,4,4,4,4,1,1,1,1,1,1,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g
DATA 4,p,0,0,0,4,0,0,0,0,0,1,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g
DATA 4,0,0,0,0,4,9,0,0,0,0,0,1,g,g,g,g,g,g,g,g,g,g,1,1,1,1,1,g,g
DATA 4,0,h,0,0,0,9,0,9,9,9,0,2,1,1,1,1,1,1,1,1,1,g,1,0,0,0,1,g,g
DATA 4,0,0,0,0,0,9,0,9,9,9,0,2,9,9,2,9,0,9,2,9,1,g,1,m,0,0,1,g,g
DATA 4,4,4,4,4,4,9,0,9,9,9,0,2,9,9,2,9,0,9,2,9,1,1,1,2,2,2,1,1,1
DATA 1,9,9,9,0,0,9,0,0,0,0,0,2,9,m,2,9,0,9,2,0,0,0,0,0,0,0,0,0,1
DATA 1,9,9,9,9,9,9,9,9,9,9,9,2,9,9,2,9,0,9,2,9,9,9,9,9,9,9,9,9,1
DATA 1,1,1,1,1,1,1,1,1,1,1,2,2,9,9,2,9,0,m,2,0,0,0,0,0,0,0,0,0,1
DATA g,g,g,g,g,g,g,g,g,g,1,0,0,0,0,2,9,0,9,2,9,0,9,0,m,0,9,0,9,1
DATA w,w,w,w,w,w,w,w,w,g,1,0,0,0,0,2,9,0,9,2,9,0,9,0,9,0,9,0,9,1
DATA w,w,w,w,w,w,w,w,w,g,1,0,0,0,0,2,9,0,9,2,9,0,9,0,9,0,9,0,9,1
DATA w,w,w,w,w,w,w,w,w,g,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,1
DATA g,g,g,g,g,g,w,w,w,g,g,g,g,g,g,4,1,0,0,0,0,0,0,9,9,9,9,9,9,1
DATA g,g,g,g,g,g,w,w,w,g,g,g,g,g,g,4,1,0,0,0,0,0,0,9,9,9,9,9,9,1
DATA g,g,g,g,g,g,w,w,w,w,w,w,w,w,g,4,1,1,1,1,1,1,1,1,1,1,1,1,1,4
DATA g,g,g,g,g,g,w,w,w,w,w,w,w,w,g,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4
DATA g,g,g,g,g,g,w,w,w,w,w,w,w,w,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g

'level 4

DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,3,3,3,3,3,3,3,3,3,3,3,3,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,3,3,0,0,0,0,m,0,0,0,0,0,0,3,3,3,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,3,0,0,0,3,3,3,3,3,3,3,3,3,0,0,0,3,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,3,2,2,2,3,e,e,e,e,e,e,e,3,0,0,p,3,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,3,0,0,m,3,e,e,e,e,e,e,e,3,h,0,0,3,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,3,0,0,0,3,3,3,4,e,e,e,e,3,2,3,3,3,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,3,m,0,0,0,0,2,s,4,e,e,e,4,s,4,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,3,3,3,3,3,3,3,s,s,4,4,4,s,s,4,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,4,s,s,s,s,s,4,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,4,4,4,4,4,4,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e

'level 5

DATA e,e,e,1,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,1,1,1,1,1,1,1,1
DATA e,e,1,3,1,e,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3
DATA e,e,1,3,1,e,1,0,0,0,0,0,0,0,0,0,0,0,0,0,m,1,3,9,9,p,h,9,9,3
DATA e,e,e,1,e,e,1,0,4,4,4,4,4,4,4,4,4,4,4,4,0,1,3,9,9,9,9,9,9,3
DATA e,e,e,e,e,e,1,0,1,0,0,0,0,0,0,0,0,0,m,1,0,1,3,3,3,3,0,3,3,3
DATA e,1,1,1,e,e,1,0,1,0,4,4,4,4,4,4,4,4,0,1,0,1,1,1,1,3,0,3,1,1
DATA e,1,3,1,e,e,1,0,1,0,1,m,0,0,0,0,0,1,0,1,0,1,e,e,e,3,0,3,e,e
DATA e,1,1,1,e,e,1,0,1,0,1,0,4,4,4,4,0,1,0,1,0,1,e,e,e,3,0,3,e,e
DATA e,e,e,e,e,e,1,0,1,0,1,0,1,s,s,0,0,1,0,1,0,1,e,e,e,3,0,3,e,e
DATA e,e,e,e,e,e,1,0,1,0,1,0,1,s,s,0,0,1,0,1,0,1,e,e,e,3,0,3,e,e
DATA 1,e,e,e,e,e,1,0,1,0,1,0,1,0,0,0,0,1,0,1,0,1,e,e,e,3,0,3,e,e
DATA e,e,e,1,1,1,1,0,1,0,1,0,4,4,4,4,4,4,0,1,0,1,e,e,e,1,0,3,e,e
DATA e,e,e,1,3,1,1,0,1,0,1,m,0,0,0,0,0,0,m,1,0,1,e,e,1,0,0,1,e,e
DATA e,e,e,1,1,1,1,0,1,0,4,4,4,4,4,4,4,4,4,4,0,1,e,1,0,0,1,e,e,e
DATA e,e,e,e,e,e,1,0,1,m,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,e,e,e,e
DATA e,e,3,1,e,e,1,0,4,4,4,4,4,4,4,4,4,4,4,4,4,4,0,0,1,e,e,e,e,e
DATA e,e,1,3,e,e,1,m,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,e,e,e,e
DATA e,e,e,e,e,e,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,e,e,e,e



'level 6

DATA 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
DATA 1,9,2,2,2,2,0,0,9,0,9,9,9,9,p,0,0,9,0,9,0,9,0,9,2,9,9,9,h,1
DATA 1,9,2,0,0,2,0,9,3,3,0,9,9,9,9,9,9,0,9,0,9,0,9,0,2,9,9,9,9,1
DATA 1,9,2,m,0,2,0,9,3,3,0,9,9,9,9,9,9,9,0,9,0,9,0,9,2,2,2,2,2,1
DATA 1,9,2,2,2,2,0,0,0,0,3,0,0,0,0,0,0,m,9,0,9,0,9,0,9,1,1,1,1,1
DATA 1,9,9,9,9,9,9,9,9,0,3,9,0,9,0,9,0,9,0,9,0,9,0,9,0,1,1,1,1,1
DATA 1,9,9,9,9,2,2,2,2,0,3,0,9,0,9,0,9,0,9,2,2,2,2,0,0,1,m,0,0,1
DATA 1,9,0,0,9,2,0,0,2,9,0,9,0,9,0,9,0,9,0,2,0,0,2,0,0,1,0,0,0,1
DATA 1,9,0,0,9,2,m,0,2,0,0,2,2,2,2,2,9,0,9,2,m,0,2,0,0,1,0,0,0,1
DATA 1,9,9,9,9,2,2,2,2,0,0,2,0,0,0,2,9,9,9,2,2,2,2,9,9,9,3,0,3,1
DATA 1,5,0,0,0,9,9,9,9,9,0,2,0,h,0,2,0,0,0,0,0,0,0,0,0,0,4,0,4,1
DATA 1,3,5,5,0,0,9,9,9,0,0,2,0,0,0,2,9,0,9,9,9,9,0,9,9,9,3,0,3,1
DATA 1,3,5,5,0,0,0,9,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,9,0,9,1
DATA 1,5,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,2,2,2,2,2,0,9,9,0,1
DATA 1,1,1,1,1,1,0,0,0,0,0,0,4,4,4,4,9,0,9,0,2,0,0,0,2,0,9,0,9,1
DATA 1,m,0,0,9,2,9,9,9,9,9,9,4,3,3,4,9,0,9,0,2,m,0,0,2,0,9,9,0,1
DATA 1,0,0,0,9,2,9,0,0,0,0,0,4,3,3,4,9,0,9,0,2,2,2,2,2,0,9,0,9,1
DATA 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1


'level 7
                                                              
DATA e,e,4,2,2,2,2,2,4,e,e,4,2,1,1,1,1,2,4,4,2,2,2,2,4,e,e,e,e,e
DATA e,e,4,2,1,1,1,2,4,4,4,4,2,1,0,0,1,2,2,4,2,1,1,2,2,4,e,e,e,e
DATA e,e,4,2,1,3,1,2,2,2,2,2,2,2,1,9,9,1,2,2,1,0,0,1,2,4,4,e,e,e
DATA e,4,4,2,1,1,1,2,2,1,e,1,1,1,1,s,s,1,2,2,1,s,s,1,2,2,4,e,e,e
DATA e,4,2,2,1,1,1,1,1,0,1,0,9,0,0,0,0,0,1,2,1,s,s,0,1,2,4,4,4,e
DATA e,4,1,1,9,9,9,9,0,0,0,0,0,0,0,0,0,0,1,2,2,1,0,0,1,2,2,4,e,e
DATA e,4,1,0,9,0,0,0,0,9,m,9,0,0,1,0,0,m,0,1,2,2,1,0,0,1,2,4,e,e
DATA e,4,2,1,9,0,9,0,0,9,0,9,0,1,3,1,0,0,0,0,1,1,1,0,0,1,2,4,4,e
DATA e,4,2,1,9,0,1,0,0,9,0,9,0,1,3,1,0,0,0,0,0,0,1,0,0,1,2,2,4,e
DATA e,4,2,1,9,1,2,1,0,0,0,9,0,1,1,3,1,0,0,0,0,0,0,0,0,0,1,2,4,e
DATA e,4,2,1,1,1,2,1,9,0,0,0,9,0,0,1,1,0,0,0,0,h,0,0,0,0,1,2,4,e
DATA e,4,2,2,2,2,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,2,4,e
DATA e,4,2,1,1,1,2,2,1,9,0,1,0,0,0,0,p,0,0,0,0,0,0,0,1,2,2,4,4,e
DATA e,4,2,1,3,3,1,1,1,0,1,2,1,0,0,0,0,0,0,0,0,0,0,0,1,2,2,4,4,e
DATA e,4,2,2,1,3,3,1,2,1,1,2,2,1,1,1,0,0,0,0,0,1,1,s,s,1,2,2,4,e
DATA e,4,4,2,1,3,3,3,1,2,2,2,2,2,2,2,1,9,9,9,1,2,2,1,0,0,1,2,4,e
DATA e,e,4,2,1,1,1,1,1,2,4,4,4,4,4,2,1,1,1,1,2,2,4,2,1,1,2,2,4,e
DATA e,e,4,2,2,2,2,2,2,2,4,e,e,e,4,2,2,2,2,2,2,4,4,2,2,2,2,4,4,e

      
'level 8

DATA 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
DATA 5,m,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,m,1
DATA 1,0,3,1,1,0,1,0,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,0,5
DATA 5,0,1,1,1,0,1,0,1,1,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1
DATA 1,0,0,0,1,0,0,0,0,0,1,0,0,3,1,1,1,1,1,1,0,1,1,1,0,1,0,1,0,5
DATA 5,0,1,0,1,1,1,0,1,0,1,1,0,1,0,0,0,0,0,1,2,0,0,0,1,0,0,1,0,1
DATA 1,0,1,0,1,1,0,0,1,0,1,1,1,3,0,1,0,1,0,1,3,0,1,0,1,1,0,1,0,5
DATA 5,0,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,0,1
DATA 1,0,1,1,1,0,1,1,1,1,1,1,0,3,9,9,4,0,4,0,4,0,1,0,1,1,0,1,0,5
DATA 5,0,1,1,0,0,2,2,2,2,0,0,0,3,9,9,1,p,1,0,1,0,1,0,2,0,0,1,0,1
DATA 1,0,0,1,1,0,1,1,1,1,1,1,0,3,9,9,1,1,2,2,1,0,0,0,1,1,0,1,0,5
DATA 5,0,1,1,1,0,1,1,1,1,1,1,0,3,3,0,3,1,2,1,1,1,1,1,1,0,0,1,0,1
DATA 1,0,1,1,0,0,0,0,0,0,0,1,0,0,0,3,1,4,0,4,0,4,0,4,0,4,0,1,0,5
DATA 5,0,1,1,0,1,0,1,0,1,0,0,0,1,0,2,h,0,0,0,0,0,0,0,0,0,0,1,0,1
DATA 1,0,0,1,1,1,1,1,1,1,1,1,0,1,0,3,1,1,1,1,1,1,1,1,1,1,1,1,0,5
DATA 5,0,3,1,1,0,1,0,1,1,0,1,0,1,0,1,1,0,1,1,0,1,1,1,0,1,0,3,0,1
DATA 1,m,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,m,5
DATA 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3


REM blank map





DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e
DATA e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e,e

DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DATA 1,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,g,g,g,g,3,3,3,3,3,3,g,g,g,g,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,g,g,g,4,1,1 1 1 1 1,4,g,g,g,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,g,g,g,3,1,s,s,s,s,1,3,g,g,g,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,3,3,3,3,1,s,s,s,s,1,3,3,3,3,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,3,4,1,1,1,9,9,9,9,1,1,1,4,3,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,3,1,M,0,0,0,0,0,0,0,0,M,1,3,g,g,g,g,g,g,g,3
DATA 1,g,g,g,g,g,g,g,3,1,0,0,0,0,0,0,0,0,0,0,1,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,3,4,1,1,0,0,0,0,0,0,1,1,4,3,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,3,3,3,3,1,M,0,0,M,1,3,3,3,3,g,g,g,g,g,g,g,g
DATA w,w,w,w,w,w,w,w,w,w,w,w,3,1,0,0,1,3,w,w,w,w,w,w,w,w,w,w,w,w
DATA w,w,w,w,w,w,w,w,w,w,w,w,3,1,0,0,1,3,w,w,w,w,w,w,w,w,w,w,w,w
DATA w,w,w,w,w,w,w,w,w,w,w,w,3,1,0,0,1,3,w,w,w,w,w,w,w,w,w,w,w,w
DATA g,g,g,g,g,g,g,g,g,g,g,3,1,9,P,H,9,1,3,g,g,g,g,g,g,g,g,g,g,g
DATA g,g,g,g,g,g,g,g,g,g,4,1,1,1,1,1,1,1,1,4,g,g,g,g,g,g,g,g,g,g

SUB beatgame (letter())
REM after you have beat the game...then it ends the game

    CLS

    PAINT (0, 0), 40, 40
    
    CALL printg("You are the CHAMP!", 160, 50, 1, 145, 1, letter())

    CALL printg("Pac-Guy has eaten", 160, 100, 1, 145, 1, letter())

    CALL printg("Enough!", 160, 150, 3, 145, 1, letter())

    CALL kbhit

    CLS

    PAINT (0, 0), 60, 60

    CALL printg("Please email me", 160, 50, 2, 145, 1, letter())

    CALL printg("and write: ", 160, 100, 2, 145, 1, letter())

    CALL printg("jphpg1", 160, 150, 2, 80, 1, letter())

    CALL kbhit

    CLS

    PAINT (0, 0), 60, 60

    CALL printg("You win NOTHING!", 160, 50, 2, 145, 1, letter())

    CALL printg("But I will put your", 160, 80, 1, 145, 1, letter())

    CALL printg("name on my page.", 160, 90, 1, 145, 1, letter())

    CALL printg("example: ", 160, 100, 1, 145, 1, letter())

    CALL printg("John Hess beat Pac-Guy first!", 155, 110, 1, 80, 1, letter())

    CALL printg("Thanks for your support", 160, 120, 1, 145, 1, letter())

    CALL printg("You win NOTHING!", 160, 150, 2, 145, 1, letter())

    CALL kbhit

    END

END SUB

SUB checkmap (pacx, pacy, way, ballx(), bally(), ballxold(), ballyold(), ballcount(), ballway(), points, finish, value(), rotateindex)
REM checks colors and map positions

    SELECT CASE way

        CASE 1

            SELECT CASE (POINT(pacx, pacy - wid))

                CASE markercolor

                    points = points + 1

                    LINE (pacx - 1, pacy - wid)-(pacx + 1, pacy - wid - 1), 0, BF

                    SOUND 200, .2

                CASE 150

            END SELECT


        CASE 2

            SELECT CASE (POINT(pacx + wid, pacy))
            
                CASE markercolor
                   
                    points = points + 1

                    LINE (pacx + wid, pacy - 1)-(pacx + wid + 1, pacy + 1), 0, BF

                    SOUND 200, .2
               
                CASE 150

            END SELECT

        CASE 3

            SELECT CASE (POINT(pacx, pacy + wid))
            
                CASE markercolor
               
                    points = points + 1

                    LINE (pacx - 1, pacy + wid - 1)-(pacx + 1, pacy + wid + 1), 0, BF

                    SOUND 200, .2
               
                CASE 150

            END SELECT

        CASE 4

            SELECT CASE (POINT(pacx - wid, pacy))
            
                CASE markercolor
                   
                    points = points + 1

                    LINE (pacx - wid, pacy - 1)-(pacx - wid - 1, pacy + 1), 0, BF

                    SOUND 200, .2
               
                CASE 150


            END SELECT

    END SELECT
    
    FOR lcv = 1 TO maxmonster

        IF (ABS(ballx(lcv) - pacx) <= 9) AND (ABS(bally(lcv) - pacy) <= 9) THEN

            finish = finish - 1

            CALL died(pacx, pacy, value())

            SELECT CASE finish

                CASE 1

                    LINE (30, 0)-(40, 10), 0, BF

                CASE 0

                    LINE (15, 0)-(25, 10), 0, BF
            
            END SELECT

REM put pacguy back and make him stop

                pacx = startpacx
                pacy = startpacy
                way = 0
                rotateindex = 1

REM put all tanks back at their starting positions
REM or else you may end up dying a whole lot

            CALL erasemonsters(ballx(), bally(), ballxold(), ballyold())
       
            CALL iniget(ballx(), bally())

        END IF

        IF (ABS(ballx(lcv) - shotx) <= 9) AND (ABS(bally(lcv) - shoty) <= 9) AND shot = 1 THEN

            ballx(lcv) = homex
            bally(lcv) = homey

            FOR t = 1 TO 2
                CIRCLE (shotx, shoty), t, t * 200

            NEXT t

            PUT (shotx - 2, shoty - 2), shotimage, PSET
           
            shot = 0

            points = points + 1

        END IF
   
    NEXT lcv


END SUB

SUB died (pacx, pacy, value())
REM when the player dies

DIM cirbackground(0 TO 200)

    PLAY "t255o0bb"

    c = 190
   
    GET (pacx - 10, pacy - 10)-(pacx + 10, pacy + 10), cirbackground

    FOR radius = 1 TO 5

        c = c + 1

        CIRCLE (pacx, pacy), radius, c

    NEXT radius

    FOR lcv = 1 TO 100

       CALL rotatecolor(rotateindex, value())

    NEXT lcv

    PUT (pacx - 10, pacy - 10), cirbackground, PSET

    LINE (pacxold - 4, pacyold - 4)-(pacxold + 4, pacyold + 4), 0, BF

END SUB

SUB drawmonsters (ballx(), bally(), ballway())

FOR lcv = 1 TO maxmonster

    GET (ballx(lcv) - 4, bally(lcv) - 4)-(ballx(lcv) + 4, bally(lcv) + 4), background(lcv * 100)

NEXT lcv

FOR lcv = 1 TO maxmonster

    SELECT CASE ballway(lcv)
        
        CASE 1

            PUT (ballx(lcv) - 4, bally(lcv) - 4), tank1, PSET

        CASE 2

            PUT (ballx(lcv) - 4, bally(lcv) - 4), tank2, PSET

        CASE 3

            PUT (ballx(lcv) - 4, bally(lcv) - 4), tank3, PSET

        CASE 4

            PUT (ballx(lcv) - 4, bally(lcv) - 4), tank4, PSET

    CASE ELSE

        CIRCLE (ballx(lcv), bally(lcv)), 4, 50

    END SELECT

NEXT lcv

END SUB

SUB drawpac (pacx, pacy, way)
REM draws pacguy

    SELECT CASE way

        CASE 1, 0

            PUT (pacx - 4, pacy - 4), pac1, PSET
            PSET (pacx - 5, pacy - 4), 0

        CASE 2

            PUT (pacx - 4, pacy - 4), pac2, PSET
            PSET (pacx + 4, pacy - 5), 0

        CASE 3

            PUT (pacx - 4, pacy - 4), pac3, PSET
            PSET (pacx - 5, pacy + 4), 0

        CASE 4

            PUT (pacx - 4, pacy - 4), pac4, PSET
            PSET (pacx - 4, pacy - 5), 0

    END SELECT

END SUB

SUB ending (letter())
REM ending

    CLS

    c = 20

    wayc = 1

    FOR y = 0 TO 199 STEP 5

        FOR x = 0 TO 319 STEP 5

            IF c >= 50 THEN wayc = 0
            IF c <= 20 THEN wayc = 1
           
            IF wayc = 1 THEN

                c = c + 3

            ELSE

                c = c - 3

            END IF

           

            

            LINE (x, y)-(x + 4, y + 4), c, B

            LINE (x + 1, y + 1)-(x + 3, y + 3), c + 5, B

            PSET (x + 2, y + 2), c + 10

        NEXT x

    NEXT y

    CALL printg("Your", 160, 50, 3, 145, 1, letter())
   
    CALL printg("A", 160, 100, 3, 145, 1, letter())

    CALL printg("LOSER!", 163, 150, 5, 145, 1, letter())

    CALL printg("(But at least your a", 160, 180, 1, 145, 1, letter())

    CALL printg("REGISTERED LOSER!)", 160, 190, 1, 145, 1, letter())

REM grab it twice incase of accidental hitting of the keys

    i$ = INKEY$
       
    i$ = INKEY$

    DO WHILE i$ = ""
      
        i$ = INKEY$

   LOOP

    CLS


END SUB

SUB erasemonsters (ballx(), bally(), ballxold(), ballyold())

FOR lcv = 1 TO maxmonster
   
   PUT (ballxold(lcv) - 4, ballyold(lcv) - 4), background(lcv * 100), PSET

NEXT lcv

END SUB

SUB erasepac (pacxold, pacyold)
REM erases the pacguy
  
    LINE (pacxold - 4, pacyold - 4)-(pacxold + 4, pacyold + 4), 0, BF

END SUB

SUB grabimage
  
REM set the image to the upper left
   
    pacx = 4
    pacy = 4
    ballx = 4
    bally = 4

REM roller
      
            LINE (pacx - 2, pacy - 4)-(pacx + 2, pacy - 4), 191
            LINE (pacx - 2, pacy - 3)-(pacx + 2, pacy - 3), 192
            LINE (pacx - 2, pacy - 2)-(pacx + 2, pacy - 2), 194

REM hooks

            PSET (pacx - 3, pacy - 3), 50
            PSET (pacx + 3, pacy - 3), 50
            LINE (pacx - 4, pacy - 3)-(pacx - 4, pacy), 40
            LINE (pacx + 4, pacy - 3)-(pacx + 4, pacy), 40

REM body

            LINE (pacx - 4, pacy)-(pacx + 4, pacy), 50
            LINE (pacx - 4, pacy + 4)-(pacx + 4, pacy + 4), 50

            LINE (pacx - 2, pacy + 1)-(pacx + 2, pacy + 3), 60, B

REM wheels

            PSET (pacx - 3, pacy + 1), 191
            PSET (pacx - 3, pacy + 2), 192
            PSET (pacx - 3, pacy + 3), 194
         
            PSET (pacx - 4, pacy + 1), 191
            PSET (pacx - 4, pacy + 2), 192
            PSET (pacx - 4, pacy + 3), 194


            PSET (pacx + 3, pacy + 1), 191
            PSET (pacx + 3, pacy + 2), 192
            PSET (pacx + 3, pacy + 3), 194
                      
            PSET (pacx + 4, pacy + 1), 191
            PSET (pacx + 4, pacy + 2), 192
            PSET (pacx + 4, pacy + 3), 194

    GET (0, 0)-(8, 8), pac1

    CLS

REM roller

            LINE (pacx + 4, pacy - 2)-(pacx + 4, pacy + 2), 191
            LINE (pacx + 3, pacy - 2)-(pacx + 3, pacy + 2), 192
            LINE (pacx + 2, pacy - 2)-(pacx + 2, pacy + 2), 194

REM hooks

            PSET (pacx + 3, pacy - 3), 50
            PSET (pacx + 3, pacy + 3), 50
            LINE (pacx + 3, pacy - 4)-(pacx, pacy - 4), 40
            LINE (pacx + 3, pacy + 4)-(pacx, pacy + 4), 40


REM body

            LINE (pacx, pacy - 4)-(pacx, pacy + 4), 50
            LINE (pacx - 4, pacy - 4)-(pacx - 4, pacy + 4), 50

            LINE (pacx - 1, pacy - 2)-(pacx - 3, pacy + 2), 60, B

REM wheels

            PSET (pacx - 1, pacy - 3), 191
            PSET (pacx - 2, pacy - 3), 192
            PSET (pacx - 3, pacy - 3), 194
        
            PSET (pacx - 1, pacy - 4), 191
            PSET (pacx - 2, pacy - 4), 192
            PSET (pacx - 3, pacy - 4), 194


            PSET (pacx - 1, pacy + 3), 191
            PSET (pacx - 2, pacy + 3), 192
            PSET (pacx - 3, pacy + 3), 194
                     
            PSET (pacx - 1, pacy + 4), 191
            PSET (pacx - 2, pacy + 4), 192
            PSET (pacx - 3, pacy + 4), 194

    GET (0, 0)-(8, 8), pac2

    CLS
   

REM roller
     
            LINE (pacx - 2, pacy + 4)-(pacx + 2, pacy + 4), 191
            LINE (pacx - 2, pacy + 3)-(pacx + 2, pacy + 3), 192
            LINE (pacx - 2, pacy + 2)-(pacx + 2, pacy + 2), 194

REM hooks

            PSET (pacx - 3, pacy + 3), 50
            PSET (pacx + 3, pacy + 3), 50
            LINE (pacx - 4, pacy + 3)-(pacx - 4, pacy), 40
            LINE (pacx + 4, pacy + 3)-(pacx + 4, pacy), 40

REM body

            LINE (pacx - 4, pacy)-(pacx + 4, pacy), 50
            LINE (pacx - 4, pacy - 4)-(pacx + 4, pacy - 4), 50

            LINE (pacx - 2, pacy - 1)-(pacx + 2, pacy - 3), 60, B

REM wheels

            PSET (pacx - 3, pacy - 1), 191
            PSET (pacx - 3, pacy - 2), 192
            PSET (pacx - 3, pacy - 3), 194
          
            PSET (pacx - 4, pacy - 1), 191
            PSET (pacx - 4, pacy - 2), 192
            PSET (pacx - 4, pacy - 3), 194


            PSET (pacx + 3, pacy - 1), 191
            PSET (pacx + 3, pacy - 2), 192
            PSET (pacx + 3, pacy - 3), 194
                       
            PSET (pacx + 4, pacy - 1), 191
            PSET (pacx + 4, pacy - 2), 192
            PSET (pacx + 4, pacy - 3), 194

    GET (0, 0)-(8, 8), pac3

    CLS
   

REM roller
    
            LINE (pacx - 4, pacy - 2)-(pacx - 4, pacy + 2), 191
            LINE (pacx - 3, pacy - 2)-(pacx - 3, pacy + 2), 192
            LINE (pacx - 2, pacy - 2)-(pacx - 2, pacy + 2), 194

REM hooks

            PSET (pacx - 3, pacy - 3), 50
            PSET (pacx - 3, pacy + 3), 50
            LINE (pacx - 3, pacy - 4)-(pacx, pacy - 4), 40
            LINE (pacx - 3, pacy + 4)-(pacx, pacy + 4), 40

REM body

            LINE (pacx, pacy - 4)-(pacx, pacy + 4), 50
            LINE (pacx + 4, pacy - 4)-(pacx + 4, pacy + 4), 50

            LINE (pacx + 1, pacy - 2)-(pacx + 3, pacy + 2), 60, B

REM wheels

            PSET (pacx + 1, pacy - 3), 191
            PSET (pacx + 2, pacy - 3), 192
            PSET (pacx + 3, pacy - 3), 194
       
            PSET (pacx + 1, pacy - 4), 191
            PSET (pacx + 2, pacy - 4), 192
            PSET (pacx + 3, pacy - 4), 194


            PSET (pacx + 1, pacy + 3), 191
            PSET (pacx + 2, pacy + 3), 192
            PSET (pacx + 3, pacy + 3), 194
                    
            PSET (pacx + 1, pacy + 4), 191
            PSET (pacx + 2, pacy + 4), 192
            PSET (pacx + 3, pacy + 4), 194

    GET (0, 0)-(8, 8), pac4

    CLS

            PSET (ballx - 4, bally - 4), 1:  'upper left track
            PSET (ballx - 3, bally - 4), 1
            PSET (ballx - 4, bally - 3), 50
            PSET (ballx - 3, bally - 3), 50

            PSET (ballx - 4, bally - 2), 4:  'upper left track
            PSET (ballx - 3, bally - 2), 4
            PSET (ballx - 4, bally - 1), 50
            PSET (ballx - 3, bally - 1), 50

            PSET (ballx - 4, bally - 0), 1:  'upper left track
            PSET (ballx - 3, bally - 0), 1
            PSET (ballx - 4, bally + 1), 50
            PSET (ballx - 3, bally + 1), 50

            PSET (ballx - 4, bally + 2), 4:  'upper left track
            PSET (ballx - 3, bally + 2), 4
            PSET (ballx - 4, bally + 3), 50
            PSET (ballx - 3, bally + 3), 50

            PSET (ballx - 4, bally + 4), 1:  'upper left track
            PSET (ballx - 3, bally + 4), 1

REM right side

            PSET (ballx + 4, bally - 4), 1:  'upper left track
            PSET (ballx + 3, bally - 4), 1
            PSET (ballx + 4, bally - 3), 50
            PSET (ballx + 3, bally - 3), 50

            PSET (ballx + 4, bally - 2), 4:  'upper left track
            PSET (ballx + 3, bally - 2), 4
            PSET (ballx + 4, bally - 1), 50
            PSET (ballx + 3, bally - 1), 50

            PSET (ballx + 4, bally - 0), 1:  'upper left track
            PSET (ballx + 3, bally - 0), 1
            PSET (ballx + 4, bally + 1), 50
            PSET (ballx + 3, bally + 1), 50

            PSET (ballx + 4, bally + 2), 4:  'upper left track
            PSET (ballx + 3, bally + 2), 4
            PSET (ballx + 4, bally + 3), 50
            PSET (ballx + 3, bally + 3), 50

            PSET (ballx + 4, bally + 4), 1:  'upper left track
            PSET (ballx + 3, bally + 4), 1

REM cannon

            LINE (ballx - 2, bally + 4)-(ballx - 2, bally - 2), 200
            LINE (ballx - 1, bally + 4)-(ballx - 1, bally - 2), 215
            LINE (ballx, bally + 3)-(ballx, bally - 2), 230
            LINE (ballx + 1, bally + 4)-(ballx + 1, bally - 2), 215
            LINE (ballx + 2, bally + 4)-(ballx + 2, bally - 2), 200


    GET (0, 0)-(8, 8), tank1

    CLS
   

            PSET (ballx - 4, bally - 4), 1
            PSET (ballx - 4, bally - 3), 1
            PSET (ballx - 3, bally - 4), 50
            PSET (ballx - 3, bally - 3), 50
 
            PSET (ballx - 2, bally - 4), 4
            PSET (ballx - 2, bally - 3), 4
            PSET (ballx - 1, bally - 4), 50
            PSET (ballx - 1, bally - 3), 50
            
            PSET (ballx - 0, bally - 4), 1
            PSET (ballx - 0, bally - 3), 1
            PSET (ballx + 1, bally - 4), 50
            PSET (ballx + 1, bally - 3), 50

            PSET (ballx + 2, bally - 4), 4
            PSET (ballx + 2, bally - 3), 4
            PSET (ballx + 3, bally - 4), 50
            PSET (ballx + 3, bally - 3), 50

            PSET (ballx + 4, bally - 4), 1
            PSET (ballx + 4, bally - 3), 1
                            
REM bottom side

            PSET (ballx - 4, bally + 4), 1
            PSET (ballx - 4, bally + 3), 1
            PSET (ballx - 3, bally + 4), 50
            PSET (ballx - 3, bally + 3), 50

            PSET (ballx - 2, bally + 4), 4
            PSET (ballx - 2, bally + 3), 4
            PSET (ballx - 1, bally + 4), 50
            PSET (ballx - 1, bally + 3), 50
           
            PSET (ballx - 0, bally + 4), 1
            PSET (ballx - 0, bally + 3), 1
            PSET (ballx + 1, bally + 4), 50
            PSET (ballx + 1, bally + 3), 50

            PSET (ballx + 2, bally + 4), 4
            PSET (ballx + 2, bally + 3), 4
            PSET (ballx + 3, bally + 4), 50
            PSET (ballx + 3, bally + 3), 50

            PSET (ballx + 4, bally + 4), 1
            PSET (ballx + 4, bally + 3), 1

REM cannon
          
            LINE (ballx - 4, bally - 2)-(ballx + 2, bally - 2), 200
            LINE (ballx - 4, bally - 1)-(ballx + 2, bally - 1), 215
            LINE (ballx - 3, bally)-(ballx + 2, bally), 230
            LINE (ballx - 4, bally + 1)-(ballx + 2, bally + 1), 215
            LINE (ballx - 4, bally + 2)-(ballx + 2, bally + 2), 200

           


    GET (0, 0)-(8, 8), tank2

    CLS
   

            PSET (ballx - 4, bally - 4), 1:  'upper left track
            PSET (ballx - 3, bally - 4), 1
            PSET (ballx - 4, bally - 3), 50
            PSET (ballx - 3, bally - 3), 50

            PSET (ballx - 4, bally - 2), 4:  'upper left track
            PSET (ballx - 3, bally - 2), 4
            PSET (ballx - 4, bally - 1), 50
            PSET (ballx - 3, bally - 1), 50

            PSET (ballx - 4, bally - 0), 1:  'upper left track
            PSET (ballx - 3, bally - 0), 1
            PSET (ballx - 4, bally + 1), 50
            PSET (ballx - 3, bally + 1), 50

            PSET (ballx - 4, bally + 2), 4:  'upper left track
            PSET (ballx - 3, bally + 2), 4
            PSET (ballx - 4, bally + 3), 50
            PSET (ballx - 3, bally + 3), 50

            PSET (ballx - 4, bally + 4), 1:  'upper left track
            PSET (ballx - 3, bally + 4), 1

REM right side

            PSET (ballx + 4, bally - 4), 1:  'upper left track
            PSET (ballx + 3, bally - 4), 1
            PSET (ballx + 4, bally - 3), 50
            PSET (ballx + 3, bally - 3), 50

            PSET (ballx + 4, bally - 2), 4:  'upper left track
            PSET (ballx + 3, bally - 2), 4
            PSET (ballx + 4, bally - 1), 50
            PSET (ballx + 3, bally - 1), 50

            PSET (ballx + 4, bally - 0), 1:  'upper left track
            PSET (ballx + 3, bally - 0), 1
            PSET (ballx + 4, bally + 1), 50
            PSET (ballx + 3, bally + 1), 50

            PSET (ballx + 4, bally + 2), 4:  'upper left track
            PSET (ballx + 3, bally + 2), 4
            PSET (ballx + 4, bally + 3), 50
            PSET (ballx + 3, bally + 3), 50

            PSET (ballx + 4, bally + 4), 1:  'upper left track
            PSET (ballx + 3, bally + 4), 1

REM cannon

            LINE (ballx - 2, bally - 4)-(ballx - 2, bally + 2), 200
            LINE (ballx - 1, bally - 4)-(ballx - 1, bally + 2), 215
            LINE (ballx, bally - 3)-(ballx, bally + 2), 230
            LINE (ballx + 1, bally - 4)-(ballx + 1, bally + 2), 215
            LINE (ballx + 2, bally - 4)-(ballx + 2, bally + 2), 200

  
    GET (0, 0)-(8, 8), tank3

    CLS
   

            PSET (ballx - 4, bally - 4), 1
            PSET (ballx - 4, bally - 3), 1
          
            PSET (ballx - 3, bally - 4), 50
            PSET (ballx - 3, bally - 3), 50
  
            PSET (ballx - 2, bally - 4), 4
            PSET (ballx - 2, bally - 3), 4
            PSET (ballx - 1, bally - 4), 50
            PSET (ballx - 1, bally - 3), 50
             
            PSET (ballx - 0, bally - 4), 1
            PSET (ballx - 0, bally - 3), 1
            PSET (ballx + 1, bally - 4), 50
            PSET (ballx + 1, bally - 3), 50

            PSET (ballx + 2, bally - 4), 4
            PSET (ballx + 2, bally - 3), 4
            PSET (ballx + 3, bally - 4), 50
            PSET (ballx + 3, bally - 3), 50

            PSET (ballx + 4, bally - 4), 1
            PSET (ballx + 4, bally - 3), 1
                             
REM bottom side

            PSET (ballx - 4, bally + 4), 1
            PSET (ballx - 4, bally + 3), 1
            PSET (ballx - 3, bally + 4), 50
            PSET (ballx - 3, bally + 3), 50
 
            PSET (ballx - 2, bally + 4), 4
            PSET (ballx - 2, bally + 3), 4
            PSET (ballx - 1, bally + 4), 50
            PSET (ballx - 1, bally + 3), 50
            
            PSET (ballx - 0, bally + 4), 1
            PSET (ballx - 0, bally + 3), 1
            PSET (ballx + 1, bally + 4), 50
            PSET (ballx + 1, bally + 3), 50

            PSET (ballx + 2, bally + 4), 4
            PSET (ballx + 2, bally + 3), 4
            PSET (ballx + 3, bally + 4), 50
            PSET (ballx + 3, bally + 3), 50

            PSET (ballx + 4, bally + 4), 1
            PSET (ballx + 4, bally + 3), 1

REM cannon
         
            LINE (ballx + 4, bally - 2)-(ballx - 2, bally - 2), 200
            LINE (ballx + 4, bally - 1)-(ballx - 2, bally - 1), 215
            LINE (ballx + 3, bally)-(ballx - 2, bally), 230
            LINE (ballx + 4, bally + 1)-(ballx - 2, bally + 1), 215
            LINE (ballx + 4, bally + 2)-(ballx - 2, bally + 2), 200


    GET (0, 0)-(8, 8), tank4

    CLS


END SUB

SUB iniget (ballx(), bally())
REM ini the gets for the background
   
FOR lcv = 1 TO maxmonster
   
    GET (ballx(lcv) - 4, bally(lcv) - 4)-(ballx(lcv) + 4, bally(lcv) + 4), background(lcv * 100)

NEXT lcv


END SUB

SUB iniletter (letter())
REM ini letters

REM tell the user its loading the fonts

    COLOR 250
   
    LOCATE 2, 1
   
    PRINT "Loading Fonts"

    FOR index = 1 TO 6080  '6016
   
        READ letter(index)
   
    NEXT index

END SUB

SUB kbhit
REM waits for input

    DO WHILE INKEY$ = "": LOOP

    CLS

END SUB

SUB keyboard (pacx, pacy, way, newway, key$, points)
REM gets the keyboard strokes

REM get key and store it in newway
   
        key$ = INKEY$

        SELECT CASE key$

            CASE "4"

                newway = 4

            CASE "6"

                newway = 2

            CASE "8"

                newway = 1

            CASE "2"

                newway = 3

            CASE "\"
            points = points + 100

            CASE " "

                IF shot = 0 THEN
               
                    shot = 1

                    SELECT CASE way

                    CASE 0, 1

                        shotway = 1
                        shotx = pacx
                        shoty = pacy - 5

                    CASE 2

                        shotway = 2
                        shotx = pacx + 5
                        shoty = pacy

                    CASE 3

                        shotway = 3
                        shotx = pacx
                        shoty = pacy + 5

                    CASE 4
                       
                        shotway = 4
                        shotx = pacx - 5
                        shoty = pacy


                END SELECT



                   
                    shotxold = shotx
                    shotyold = shoty

                    GET (shotx - 2, shoty - 2)-(shotx + 2, shoty + 2), shotimage

                END IF

            CASE ELSE

                newway = newway

        END SELECT

        

        IF canigo = 2 THEN canigo = 0

        canigo = canigo + 1

REM wait for it to be a possible turn, then update way with newway

        IF way = 0 THEN canigo = 1

        SELECT CASE newway

        CASE 1

            IF POINT(pacx, pacy - wid - 1) <> backcolor AND POINT(pacx - wid + 1, pacy - wid - 1) <> backcolor AND POINT(pacx + wid - 1, pacy - wid - 1) <> backcolor AND canigo = 1 THEN

                IF pacx / 5 = INT(pacx / 5) AND pacy / 5 = INT(pacy / 5) AND newway <> 0 THEN

                    way = newway

                END IF
               
          
            END IF

        CASE 2

            IF POINT(pacx + wid, pacy) <> backcolor AND POINT(pacx + wid, pacy - wid + 1) <> backcolor AND POINT(pacx + wid, pacy + wid - 1) <> backcolor AND canigo = 1 THEN

                IF pacx / 5 = INT(pacx / 5) AND pacy / 5 = INT(pacy / 5) AND newway <> 0 THEN

                    way = newway

                END IF
               
              

            END IF

        CASE 3

            IF POINT(pacx, pacy + wid) <> backcolor AND POINT(pacx - wid + 1, pacy + wid) <> backcolor AND POINT(pacx + wid - 1, pacy + wid) <> backcolor AND canigo = 1 THEN

                IF pacx / 5 = INT(pacx / 5) AND pacy / 5 = INT(pacy / 5) AND newway <> 0 THEN

                    way = newway

                END IF
               


            END IF

        CASE 4

            IF POINT(pacx - wid - 1, pacy) <> backcolor AND POINT(pacx - wid - 1, pacy - wid + 1) <> backcolor AND POINT(pacx - wid - 1, pacy + wid - 1) <> backcolor AND canigo = 1 THEN

                IF pacx / 5 = INT(pacx / 5) AND pacy / 5 = INT(pacy / 5) AND newway <> 0 THEN

                    way = newway

                END IF
               


            END IF


    END SELECT

END SUB

SUB lives
REM places lives at the top

    PUT (15, 0), pac1, PSET

    PUT (30, 0), pac1, PSET

END SUB

SUB loadmap (map$(), marker, letter(), ballx(), bally(), ballway(), ballcount(), ballxold(), ballyold(), pacx, pacy, pacxold, pacyold)
REM loads the map

REM marker is the amount of markers(flashing dots) in the games
   
    marker = 0

    DIM scg(0 TO 5)

    scg(1) = 191
    scg(2) = 192
    scg(3) = 193
    scg(4) = 194
    fgc = 0
    nosteel = 0
    maxmonster = 0

    FOR y = 1 TO 18
       
        FOR x = 1 TO 30

            READ map$(x, y)

            grafx = x * 10

            grafy = y * 10
       
            SELECT CASE UCASE$(map$(x, y))

                CASE "0"

REM markers
                   
                    marker = marker + 1

                    PSET (grafx + 4, grafy + 4), markercolor

                    PSET (grafx + 5, grafy + 5), markercolor

                    PSET (grafx + 4, grafy + 5), 1

                    PSET (grafx + 5, grafy + 4), 1


                CASE "1"

REM red box with green center

                    LINE (grafx, grafy)-(grafx + 9, grafy + 9), 150, B
                   
                    LINE (grafx + 1, grafy + 1)-(grafx + 8, grafy + 8), 160, B
                   
                    LINE (grafx + 2, grafy + 2)-(grafx + 7, grafy + 7), 170, B
                   
                    LINE (grafx + 3, grafy + 3)-(grafx + 6, grafy + 6), 180, B
                   
                    PAINT (grafx + 4, grafy + 4), 110, 170
               
                CASE "2"

REM fake red box
                    LINE (grafx, grafy)-(grafx + 9, grafy + 9), 140, B
                  
                    LINE (grafx + 1, grafy + 1)-(grafx + 8, grafy + 8), 145, B
                  
                    LINE (grafx + 2, grafy + 2)-(grafx + 7, grafy + 7), 155, B
                  
                    LINE (grafx + 3, grafy + 3)-(grafx + 6, grafy + 6), 160, B
                  
                    PAINT (grafx + 4, grafy + 4), 100, 160
               
                CASE "3"

REM flashing green block

                    fgc = fgc + 1

                    IF fgc > 4 THEN fgc = 1

                    LINE (grafx, grafy)-(grafx + 9, grafy + 9), 150, B

                    PAINT (grafx + 1, grafy + 1), fgc, 150
                   
                CASE "4"

REM gray scaled square


                    FOR lcv = 1 TO 3

                        SWAP scg(lcv), scg(lcv + 1)

                    NEXT lcv

                    
                    LINE (grafx, grafy)-(grafx + 9, grafy + 9), 150, B
                  
                    LINE (grafx + 1, grafy + 1)-(grafx + 8, grafy + 8), scg(1), B
                  
                    LINE (grafx + 2, grafy + 2)-(grafx + 7, grafy + 7), scg(2), B
                  
                    LINE (grafx + 3, grafy + 3)-(grafx + 6, grafy + 6), scg(3), B

                    LINE (grafx + 4, grafy + 4)-(grafx + 5, grafy + 5), scg(4), B

                CASE "5"

REM green scaled square(up and down)
               
                    LINE (grafx, grafy)-(grafx, grafy + 9), 150
                    LINE (grafx + 9, grafy)-(grafx + 9, grafy + 9), 150
                    LINE (grafx + 1, grafy)-(grafx + 8, grafy), 1
                    LINE (grafx + 1, grafy + 1)-(grafx + 8, grafy + 1), 1
                    LINE (grafx + 1, grafy + 2)-(grafx + 8, grafy + 2), 1
                    LINE (grafx + 1, grafy + 3)-(grafx + 8, grafy + 3), 2
                    LINE (grafx + 1, grafy + 4)-(grafx + 8, grafy + 4), 2
                    LINE (grafx + 1, grafy + 5)-(grafx + 8, grafy + 5), 3
                    LINE (grafx + 1, grafy + 6)-(grafx + 8, grafy + 6), 3
                    LINE (grafx + 1, grafy + 7)-(grafx + 8, grafy + 7), 4
                    LINE (grafx + 1, grafy + 8)-(grafx + 8, grafy + 8), 4
                    LINE (grafx + 1, grafy + 9)-(grafx + 8, grafy + 9), 4

              CASE "7"



              CASE "8"


           
              CASE "9"

              CASE "H"

                    homex = x * 10 + 5
                    homey = y * 10 + 5
                    LINE (grafx, grafy)-(grafx + 9, grafy + 9), 0, BF

              CASE "S"

                    nosteel = nosteel + 1

                    steelx(nosteel) = x * 10
                    steely(nosteel) = y * 10

              CASE "P"

                    pacx = x * 10 + 5
                    pacy = y * 10 + 5

                    startpacx = pacx
                    startpacy = pacy
                    pacxold = pacx

                    pacyold = pacy

              CASE "M"

                    maxmonster = maxmonster + 1

                    ballx(maxmonster) = x * 10 + 5

                    bally(maxmonster) = y * 10 + 5

                    ballway(maxmonster) = INT(RND * 4) + 1
     
                    ballcount(maxmonster) = INT(RND * 10) + 5

                    GET (ballx(maxmonster) - 4, bally(maxmonster) - 4)-(ballx(maxmonster) + 4, bally(maxmonster) + 4), background(maxmonster * 100)

                    ballxold(maxmonster) = ballx(maxmonster)
                    ballyold(maxmonster) = bally(maxmonster)

                CASE "W"

                            LINE (grafx, grafy)-(grafx + 9, grafy + 9), 40, BF

                            PSET (grafx, grafy + 6), 42
                            PSET (grafx + 1, grafy + 6), 44
                            PSET (grafx + 2, grafy + 5), 46
                            PSET (grafx + 3, grafy + 5), 48
                            PSET (grafx + 4, grafy + 4), 50
                            PSET (grafx + 5, grafy + 4), 50
                            PSET (grafx + 6, grafy + 5), 48
                            PSET (grafx + 7, grafy + 5), 46
                            PSET (grafx + 8, grafy + 6), 44
                            PSET (grafx + 9, grafy + 6), 42

                          

                CASE "G"

                            LINE (grafx, grafy)-(grafx + 9, grafy + 9), 110, BF

                            LINE (grafx, grafy + 9)-(grafx, grafy + 6), 112
                            LINE (grafx + 1, grafy + 9)-(grafx + 1, grafy + 6), 114
                            LINE (grafx + 2, grafy + 9)-(grafx + 2, grafy + 5), 116
                            LINE (grafx + 3, grafy + 9)-(grafx + 3, grafy + 5), 118
                            LINE (grafx + 4, grafy + 9)-(grafx + 4, grafy + 4), 120
                            LINE (grafx + 5, grafy + 9)-(grafx + 5, grafy + 4), 120
                            LINE (grafx + 6, grafy + 9)-(grafx + 6, grafy + 5), 118
                            LINE (grafx + 7, grafy + 9)-(grafx + 7, grafy + 5), 116
                            LINE (grafx + 8, grafy + 9)-(grafx + 8, grafy + 6), 114
                            LINE (grafx + 9, grafy + 9)-(grafx + 9, grafy + 6), 112

                            


                CASE "F"

                            LINE (grafx, grafy)-(grafx + 9, grafy + 9), 180, BF

                            FOR lcv = 1 TO 3

                                ranx = INT(RND * 9) + 1
                                rany = INT(RND * 9) + 1
                                c = INT(RND * 50) + 130

                                PSET (grafx + ranx, grafy + rany), c

                            NEXT lcv

                          
                
                CASE "E"

                            LINE (grafx, grafy)-(grafx + 9, grafy + 9), 0, BF

                            FOR lcv = 1 TO 1

                                ranx = INT(RND * 9) + 1
                                rany = INT(RND * 9) + 1
                                c = INT(RND * 30) + 200

                                PSET (grafx + ranx - 1, grafy + rany), c - 5
                                PSET (grafx + ranx + 1, grafy + rany), c - 5
                                PSET (grafx + ranx, grafy + rany - 1), c - 5
                                PSET (grafx + ranx, grafy + rany + 1), c - 5
                                PSET (grafx + ranx, grafy + rany), c

                            NEXT lcv

                          

            END SELECT

        NEXT x

    NEXT y


    CALL printg("Pacguy By:  JOHN HESS", 160, 4, 1, 20, 1, letter())

    CALL printg("Pacguy By:  JOHN HESS", 160, 195, 1, 20, 1, letter())

    

END SUB

SUB makecolors (value())
REM makes color values
   
REM tell the user its making color

COLOR 250

LOCATE 1, 1

PRINT "Loading Palette"

    index = 0
    blue = 0
    green = 0
    red = 0

REM rotating green colors(1 thru 5)

    FOR green = 35 TO 60 STEP 5
       
        index = index + 1

        value(index) = 65536 + 256 * green

    NEXT green

    green = 0

REM blue colors(6 thru 63)

    FOR blue = 6 TO 63
       
        index = index + 1
       
        value(index) = 65536 * blue + 256 * green + red
   
    NEXT blue

    blue = 0
    green = 0
    red = 0

REM green colors(64 thru 127)
  
    FOR green = 1 TO 63
       
        index = index + 1
       
        value(index) = 65536 * blue + 256 * green + red
   
    NEXT green

    blue = 0
    green = 0
    red = 0

REM red colors(128 thru 190)

    FOR red = 1 TO 63
       
        index = index + 1
       
        value(index) = 65536 * blue + 256 * green + red
   
    NEXT red

REM make 191 darker for the rotating wheel effect

    index = index + 1

    value(index) = 65536 * 20 + 256 * 20 + 20
   
REM rotating grey colors(191 thru 194)

    FOR black = 40 TO 60 STEP 5

        index = index + 1

        value(index) = 65536 * black + 256 * black + black

    NEXT black

    black = 0


REM grey colors(195 thru 255)

    FOR black = 6 TO 63
       
        index = index + 1
       
        value(index) = 65536 * black + 256 * black + black
   
    NEXT black

END SUB

SUB makepalette (value())
REM makes palette

    FOR index = 1 TO 256
       
        PALETTE (index), (value(index))

    NEXT index

END SUB

SUB movemonsters (ballx(), bally(), ballway(), ballcount())
REM moves the bouncing ball

    FOR lcv = 1 TO maxmonster

        'F ballcount(lcv) <> 99 THEN ballcount(lcv) = ballcount(lcv) + 1
        ballcount(lcv) = ballcount(lcv) + 1
        IF ballcount(lcv) = 20 THEN

            ballway(lcv) = INT(RND * 4) + 1

            ballcount(lcv) = 0

        END IF


        SELECT CASE ballway(lcv)

            CASE 1

                IF POINT(ballx(lcv), bally(lcv) - 5) <> backcolor2 AND POINT(ballx(lcv) - 4, bally(lcv) - 5) <> backcolor2 AND POINT(ballx(lcv) + 4, bally(lcv) - 5) <> backcolor2 THEN

                    IF POINT(ballx(lcv), bally(lcv) - 5) <> backcolor AND POINT(ballx(lcv) - 4, bally(lcv) - 5) <> backcolor AND POINT(ballx(lcv) + 4, bally(lcv) - 5) <> backcolor THEN

                        bally(lcv) = bally(lcv) - 1

                    END IF

                END IF
               
            CASE 2

                IF POINT(ballx(lcv) + 5, bally(lcv)) <> backcolor2 AND POINT(ballx(lcv) + 5, bally(lcv) - 4) <> backcolor2 AND POINT(ballx(lcv) + 5, bally(lcv) + 4) <> backcolor2 THEN

                    IF POINT(ballx(lcv) + 5, bally(lcv)) <> backcolor AND POINT(ballx(lcv) + 5, bally(lcv) - 4) <> backcolor AND POINT(ballx(lcv) + 5, bally(lcv) + 4) <> backcolor THEN

                        ballx(lcv) = ballx(lcv) + 1

                    END IF

                END IF

            CASE 3

                IF POINT(ballx(lcv), bally(lcv) + 5) <> backcolor2 AND POINT(ballx(lcv) - 4, bally(lcv) + 5) <> backcolor2 AND POINT(ballx(lcv) + 4, bally(lcv) + 5) <> backcolor2 THEN

                    IF POINT(ballx(lcv), bally(lcv) + 5) <> backcolor AND POINT(ballx(lcv) - 4, bally(lcv) + 5) <> backcolor AND POINT(ballx(lcv) + 4, bally(lcv) + 5) <> backcolor THEN

                        bally(lcv) = bally(lcv) + 1

                    END IF

                END IF

            CASE 4

                IF POINT(ballx(lcv) - 5, bally(lcv)) <> backcolor2 AND POINT(ballx(lcv) - 5, bally(lcv) - 4) <> backcolor2 AND POINT(ballx(lcv) - 5, bally(lcv) + 4) <> backcolor2 THEN

                    IF POINT(ballx(lcv) - 5, bally(lcv)) <> backcolor AND POINT(ballx(lcv) - 5, bally(lcv) - 4) <> backcolor AND POINT(ballx(lcv) - 5, bally(lcv) + 4) <> backcolor THEN

                        ballx(lcv) = ballx(lcv) - 1

                    END IF

                END IF

        END SELECT

    NEXT lcv

END SUB

SUB movepac (pacx, pacy, way)
REM moves pacguy to new position if possible

REM move depending on way
REM 1 = forward
REM 2 = right
REM 3 = backword
REM 4 = left


    SELECT CASE way

        CASE 1

REM go forward if possible

            IF POINT(pacx, pacy - wid - 1) <> backcolor AND POINT(pacx - wid + 1, pacy - wid - 1) <> backcolor AND POINT(pacx + wid - 1, pacy - wid - 1) <> backcolor THEN

                pacy = pacy - 1
           
            END IF

        CASE 2

REM go right if possible

            IF POINT(pacx + wid, pacy) <> backcolor AND POINT(pacx + wid, pacy - wid + 1) <> backcolor AND POINT(pacx + wid, pacy + wid - 1) <> backcolor THEN

                pacx = pacx + 1
               

            END IF

        CASE 3

REM go backward if possible
           
            IF POINT(pacx, pacy + wid) <> backcolor AND POINT(pacx - wid + 1, pacy + wid) <> backcolor AND POINT(pacx + wid - 1, pacy + wid) <> backcolor THEN

                pacy = pacy + 1


            END IF

        CASE 4

REM go left if possible
           
            IF POINT(pacx - wid - 1, pacy) <> backcolor AND POINT(pacx - wid - 1, pacy - wid + 1) <> backcolor AND POINT(pacx - wid - 1, pacy + wid - 1) <> backcolor THEN

                pacx = pacx - 1


            END IF


    END SELECT

END SUB

SUB opening (letter(), value())

    CLS

REM grey scaled bar
REM CoOl EfFect

c = 200
bar = 0

    FOR y = 0 TO 199

        IF c = 250 THEN bar = 0

        IF c = 200 THEN bar = 1

        IF bar = 0 THEN c = c - 1

        IF bar = 1 THEN c = c + 1
                    
        LINE (0, y)-(319, y), c

    NEXT y


REM From The Producer of.........

    CALL printg("From the", 160, 40, 2, 145, 1, letter())

    CALL printg("Producer of", 160, 60, 2, 145, 1, letter())

    CALL printg("Black Sun", 160, 80, 2, 85, 1, letter())

    CALL printg("And", 160, 100, 2, 145, 1, letter())

    CALL printg("Jewel Hunter", 160, 120, 2, 85, 1, letter())

    CALL printg("I Bring", 160, 140, 2, 145, 1, letter())

    CALL printg("to You...", 160, 160, 2, 145, 1, letter())
   
    DO WHILE INKEY$ = "": LOOP
   
    CALL trans(1, 0)

REM set the values for the square

    x1 = 0
    y1 = 0
    x2 = 319
    y2 = 199

REM set color to the brightest blue

    c = 60

REM make the background

    DO WHILE x1 <= 155

        x1 = x1 + 1
        y1 = y1 + 1
        x2 = x2 - 1
        y2 = y2 - 1
        c = c - .2

        LINE (x1, y1)-(x2, y2), c, B

    LOOP

REM pacguy and john hess in 3-d

    CALL printg("PACGUY", 157, 97, 4, 20, 0, letter())

    'CALL printg("PACGUY", 160, 100, 4, 145, 1, letter())

    CALL printg("P", 60, 100, 4, 145, 1, letter())

    CALL printg("A", 100, 100, 4, 85, 1, letter())

    CALL printg("C", 140, 100, 4, 145, 1, letter())
   
    CALL printg("G", 180, 100, 4, 85, 1, letter())
   
    CALL printg("U", 220, 100, 4, 145, 1, letter())
   
    CALL printg("Y", 260, 100, 4, 85, 1, letter())
   
    CALL printg("By: John Hess", 158, 168, 2, 20, 0, letter())

    CALL printg("By: John Hess", 160, 170, 2, 80, 1, letter())

REM waits for a keyboard hit
   
    DO WHILE INKEY$ = "": LOOP
   
    CALL trans(1, 0)

REM loop with the scrolling colors

    done = 0

DO WHILE done = 0

    done = 0

    x1 = 0
    y1 = 0
    x2 = 319
    y2 = 199

    c = 1

REM make the square(as in the above)

    DO WHILE x1 <= 155

        x1 = x1 + 1
        y1 = y1 + 1
        x2 = x2 - 1
        y2 = y2 - 1
        c = c + 1
        IF c > 4 THEN c = 1

        LINE (x1, y1)-(x2, y2), c, B

    LOOP

REM make the menu

    CALL printg("&Begin Game", 160, 40, 2, 145, 1, letter())

    CALL printg("&Story", 160, 70, 2, 145, 1, letter())

    CALL printg("&Instructions", 160, 100, 2, 145, 1, letter())

    CALL printg("&Level Select", 160, 130, 2, 145, 1, letter())

    CALL printg("&Quit", 160, 160, 2, 145, 1, letter())

REM capture the keystroke
   
    i$ = INKEY$

    DO WHILE i$ = ""

        CALL rotatecolor(rotateindex, value())

        i$ = INKEY$

        IF UCASE$(i$) <> "B" AND UCASE$(i$) <> "S" AND UCASE$(i$) <> "I" AND UCASE$(i$) <> "L" AND UCASE$(i$) <> "Q" THEN

            i$ = ""

        END IF

    LOOP

REM check to see what it was

    SELECT CASE UCASE$(i$)

        CASE "B"

REM start the game

            CALL trans(3, 0)

            done = 1

        CASE "S"

REM show the story and then return back to main menu

            CLS

            PAINT (0, 0), 60, 60

            CALL printg("Story", 160, 30, 3, 80, 1, letter())

            CALL printg("After living a plain life as", 160, 50, 1, 145, 1, letter())

            CALL printg("a regular Pacguy, you were put", 160, 70, 1, 145, 1, letter())
           
            CALL printg("in control of the military,", 160, 90, 1, 145, 1, letter())

            CALL printg("destined to live the rest", 160, 110, 1, 145, 1, letter())

            CALL printg("of your life killing enemy", 160, 130, 1, 145, 1, letter())

            CALL printg("tanks as any good", 160, 150, 1, 145, 1, letter())

            CALL printg("steamroller should...", 160, 170, 1, 145, 1, letter())

            CALL printg("Email me at jameshes@seidata.com", 158, 194, 1, 145, 1, letter())

            CALL kbhit

            done = 0

        CASE "I"

REM show the instructions and return back to main menu

            CLS

            PAINT (0, 0), 60, 60

            CALL printg("Spacebar", 160, 50, 2, 145, 1, letter())

            CALL printg("now", 160, 100, 2, 145, 1, letter())

            CALL printg("SHOOTS", 160, 150, 2, 145, 1, letter())

            CALL kbhit

            CLS

            PAINT (0, 0), 60, 60

            CALL printg("Instructions", 160, 20, 2, 80, 1, letter())

            CALL printg("Just get all of", 160, 50, 1, 145, 1, letter())

            CALL printg("the flashing dots!!", 160, 70, 1, 145, 1, letter())

            CALL printg("8", 160, 90, 2, 145, 1, letter())

            CALL printg("4    6", 160, 110, 2, 145, 1, letter())

            CALL printg("2", 160, 130, 2, 145, 1, letter())

            CALL printg("Use the keypad", 160, 150, 1, 145, 1, letter())

            CALL printg("above to move", 160, 160, 1, 145, 1, letter())

            CALL printg("PACGUY!", 160, 180, 2, 145, 1, letter())

            CALL printg("Email me at jameshes@seidata.com", 158, 194, 1, 145, 1, letter())

            CALL kbhit

            done = 0

        CASE "L"

        PAINT (0, 0), 60, 60

        CALL printg("Level Entry", 160, 20, 2, 80, 1, letter())

        CALL printg("Please enter a level", 160, 80, 1, 145, 1, letter())

        CALL printg("1 - 8", 160, 120, 2, 145, 1, letter())

        CALL printg("Level Entry", 160, 170, 2, 80, 1, letter())


        i$ = INKEY$

        DO WHILE i$ = "" OR i$ < "1" OR i$ > "8"

            i$ = INKEY$

        LOOP

        level = VAL(i$)


        FOR lcv = 1 TO level - 1

            FOR wasteread = 1 TO 540
           
                READ waste$
           
            NEXT wasteread

        NEXT lcv

            CALL trans(3, 0)

            done = 1
        


        CASE "Q"

REM show quitting screen the end it
       
            CLS

            PAINT (0, 0), 60, 60

            CALL printg("Thanks", 160, 50, 4, 145, 1, letter())

            CALL printg("For", 160, 100, 4, 145, 1, letter())

            CALL printg("Playing!", 167, 150, 4, 145, 1, letter())

            CALL printg("Email me at jameshes@seidata.com", 158, 194, 1, 145, 1, letter())
           
            DO WHILE INKEY$ = "": LOOP

            CALL trans(3, 0)

            CLS

            END

    END SELECT

LOOP

END SUB

SUB printg (sentence$, x, y, scale, c, flagshade, letter())
REM prints graphical characters

REM finds the length of the sentence
   
    length = LEN(sentence$)

REM find the center x position
   
    x = x - (length * 10 * (scale / 2)) + (scale * 2)
   
REM find the center y position

    y = y - (scale * 5)

REM save time

    widthscale = 8 * scale

REM loop until you get to the end of the sentence

                          
    lcv = 0

    DO WHILE lcv < length

    lcv = lcv + 1

REM place the color into newc
   
        newc = c

REM find new letter
   
        letter$ = MID$(sentence$, lcv, 1)

        IF letter$ = "&" THEN

            lcv = lcv + 1

            letter$ = MID$(sentence$, lcv, 1)
  
            newc = 15

        END IF

REM find spot in array

        index = (ASC(letter$) - 33) * 64
   
        indexold = index

        IF letter$ <> " " THEN

REM loop for the y scale
       
            FOR ypos = 1 TO widthscale STEP scale
       
REM option for shading
               
                IF flagshade = 1 THEN
           
                    newc = newc + 5
       
                END IF

REM main scale loop
     
                FOR times = 1 TO scale
       
REM x scale loop
                   
                    FOR xpos = 1 TO widthscale STEP scale
                   
REM shading option 2
                       
                        IF flagshade = 2 THEN
                       
                            newc = newc + 1
                       
                        END IF

REM find next pixel
                       
                        index = index + 1
           
REM if pixel is lit then draw it
                       
                        IF letter(index) <> 0 THEN
                           
                            LINE (xpos + x, ypos + y)-(xpos + x + scale, ypos + y), newc
                       
                        END IF
       
                    NEXT xpos
           
                    IF flagshade = 2 THEN
               
                        newc = c
           
                    END IF
     
REM reset index
                   
                    index = index - 8
           
                    ypos = ypos + 1
     
                NEXT times
     
                index = index + 8
     
                ypos = ypos - scale
       
            NEXT ypos
   
        END IF
   
        x = x + (10 * scale)

        

    LOOP

END SUB

SUB rotatecolor (rotateindex, value())
REM rotates green
REM rotates the outside blocks


    rotateindex = rotateindex + 1
    IF rotateindex > 5 THEN rotateindex = 1

    SWAP value(rotateindex), value(rotateindex + 1)

    PALETTE (rotateindex), (value(rotateindex))

    SWAP value(rotateindex + 190), value(rotateindex + 191)

    PALETTE (rotateindex + 190), (value(rotateindex + 190))


END SUB

SUB shoots
REM shoots a bullet

    SELECT CASE shotway

    CASE 1

        IF POINT(shotx, shoty - 4) <> 150 THEN
       
            shoty = shoty - 2

        ELSE



            shot = 0

        END IF
    
    CASE 2
       
        IF POINT(shotx + 3, shoty) <> 150 THEN
       
            shotx = shotx + 2

        ELSE



            shot = 0

        END IF


        
    CASE 3
       
        IF POINT(shotx, shoty + 3) <> 150 THEN
       
            shoty = shoty + 2

        ELSE

           
            shot = 0

        END IF


       
    CASE 4
       
        IF POINT(shotx - 4, shoty) <> 150 THEN
      
           
            shotx = shotx - 2

        ELSE

            shot = 0


        END IF


    END SELECT

    
    PUT (shotxold - 2, shotyold - 2), shotimage, PSET
   
    GET (shotx - 2, shoty - 2)-(shotx + 2, shoty + 2), shotimage

    PSET (shotx, shoty), 90
    CIRCLE (shotx, shoty), 1, 100
    CIRCLE (shotx, shoty), 2, 110

    IF shot = 0 THEN PUT (shotxold - 2, shotyold - 2), shotimage, PSET

    
  
    shotxold = shotx
    shotyold = shoty

END SUB

SUB smooth (startx, starty, amount)
REM smooths the playing field
REM interesting effect

FOR lcv = 1 TO amount

    FOR smoothy = starty + 1 TO starty + 8
       
        FOR smoothx = startx + 1 TO startx + 8

            IF POINT(smoothx, smoothy) <> 0 THEN

            PSET (smoothx, smoothy), (POINT(smoothx, smoothy) + POINT(smoothx + 1, smoothy) + POINT(smoothx, smoothy + 1) + POINT(smoothx - 1, smoothy) + POINT(smoothx, smoothy - 1)) / 5 + INT(RND * 8)

            END IF

        NEXT smoothx

    NEXT smoothy

NEXT lcv

END SUB

SUB trans (flag, c)
REM screen transitions

    SELECT CASE flag

        CASE 1

REM square

            x1 = 160
            
            x2 = 160

            y1 = 100

            y2 = 100

            DO WHILE x1 > 0

                x1 = x1 - 1

                x2 = x2 + 1

                y1 = y1 - 1

                y2 = y2 + 1

                LINE (x1, y1)-(x2, y2), c, BF

            LOOP

        CASE 2

REM circle

            FOR radius = 1 TO 200

                CIRCLE (160, 100), radius, c

            NEXT radius

        CASE 3

REM dots
           
            FOR times = 1 TO 1000

                x = INT(RND * 317)

                y = INT(RND * 197)

                LINE (x, y)-(x + 3, y + 3), c, BF

                FOR t = 1 TO 200: NEXT t

            NEXT times

            CLS
   
    END SELECT

                   

END SUB

SUB uppermap
REM draws the uppermap items

    FOR lcv = 1 TO nosteel


        LINE (steelx(lcv), steely(lcv) + 4)-(steelx(lcv) + 9, steely(lcv) + 4), 220
        LINE (steelx(lcv), steely(lcv) + 5)-(steelx(lcv) + 9, steely(lcv) + 5), 250
        LINE (steelx(lcv), steely(lcv) + 6)-(steelx(lcv) + 9, steely(lcv) + 6), 220

        LINE (steelx(lcv) + 4, steely(lcv))-(steelx(lcv) + 4, steely(lcv) + 3), 220
        LINE (steelx(lcv) + 5, steely(lcv))-(steelx(lcv) + 5, steely(lcv) + 3), 250
        LINE (steelx(lcv) + 6, steely(lcv))-(steelx(lcv) + 6, steely(lcv) + 3), 220
        
        LINE (steelx(lcv) + 4, steely(lcv) + 7)-(steelx(lcv) + 4, steely(lcv) + 9), 220
        LINE (steelx(lcv) + 5, steely(lcv) + 7)-(steelx(lcv) + 5, steely(lcv) + 9), 250
        LINE (steelx(lcv) + 6, steely(lcv) + 7)-(steelx(lcv) + 6, steely(lcv) + 9), 220
        



    NEXT lcv

END SUB

SUB winner (letter())
REM winning screen
   
    CLS

    c = 65

    level = level + 1

            newc = c

            FOR lcv = 0 TO 159

                newc = newc + .2

                LINE (lcv, 0)-(lcv, 199), newc

            NEXT lcv

            FOR lcv = 160 TO 319

                newc = newc - .2

                LINE (lcv, 0)-(lcv, 199), newc

            NEXT lcv


            CALL printg("Level" + STR$(level - 1), 160, 50, 3, 145, 1, letter())

            CALL printg("COMPLETE", 160, 150, 3, 145, 1, letter())

            CALL kbhit

            newc = c

            FOR lcv = 0 TO 159

                newc = newc + .3

                LINE (lcv, 0)-(lcv, 199), newc

            NEXT lcv

            FOR lcv = 160 TO 319

                newc = newc - .3

                LINE (lcv, 0)-(lcv, 199), newc

            NEXT lcv

            IF level < 8 THEN

            CALL printg("Entering", 160, 50, 3, 145, 1, letter())
           
            CALL printg("Level" + STR$(level), 160, 150, 3, 145, 1, letter())

            ELSEIF level = 8 THEN

                CALL printg("Last Level", 160, 100, 2, 145, 1, letter())
                CALL printg("Of course you have", 160, 170, 1, 145, 1, letter())
                CALL printg("to beat the classic", 160, 180, 1, 145, 1, letter())
                CALL printg("Shareware Level!", 160, 190, 1, 145, 1, letter())

            ELSE

                CALL beatgame(letter())

            END IF


    CALL kbhit



END SUB

