10 REM $LINESIZE:132
20 REM ----------------------------------------------------------------------
30 REM
40 REM           The Game of Klondyke Solitar
50 REM           By:  Jeff Littlefield
60 REM           For: the IBM PC and the Color Graphics Card
70 REM
80 REM           FOR PUBLIC USE    MAY NOT BE SOLD
90 REM           ALL  RIGHTS  RESERVED
100 REM
110 REM ---------------------------------------------------------------------
120 DEFINT  A-Z
130 FALSE=0:TRUE = NOT FALSE : ABORT = FALSE : WON = FALSE
140 DIM DECK$(52), STACK$(7,21),CARD$(52),TOP$(4),STACKPTR(7),VISIPTR(7),XYARR$(82)
150 NOT.READ=TRUE
160 KEY OFF: KEY(1) ON: ON KEY(1) GOSUB 970
170 RANDOMIZE(VAL(MID$(TIME$,7,2))+(VAL(MID$(TIME$,4,2))*60))
180 SCREEN 0,1,0,0:COLOR 7,1,1:CLS:PRINT"Pardon me while I shuffle the deck."
190 LOCATE ,,0
200 GOSUB 830 : GOTO 210 'SET UP THE HELP SCREEN
210 GOSUB 310            'SHUFFLE THE DECK
220 CLS
230 GOSUB 590            'PRINT OUT THE PLAYING TABLE
240 WON = FALSE
250 GOTO 990
260 IF FLAG=1 THEN GOSUB 2450 ELSE GOSUB 2090
270 IF ABORT THEN ABORT = FALSE : GOTO 250
280 FLAG=0:GOSUB 2340           'ASK IF THEY WANT TO PLAY AGAIN
290 IF ABORT THEN ABORT = FALSE : GOTO 250
300 CLS:IF FLAG=1 THEN 180 ELSE KEY ON:COLOR 7,0,0:CLS:END
310 RESTORE
320 FOR I=1 TO 52:READ CARD$(I):NEXT I
330 FOR I= 52 TO 1 STEP -1
340     X=INT(RND(1)*I)+1       'PICK NUMBER FROM 1 TO I
350     DECK$(I)=CARD$(X)       'PICK THAT CARD OUT OF THE PILE
360     CARD$(X)=CARD$(I)       'MOVE LAST CARD TO WHERE PREVIOUS ONE WAS
370 NEXT I
380 X=1                         'DECK COUNTER
390 FOR I=1 TO 7                'NUMBER OF STACKS
400   FOR J=1 TO I              'NUMBER OF CARDS IN THAT STACK
410     STACK$(I,J)=DECK$(X)    'ASSIGN CARDS TO STACK
420     X=X+1
430   NEXT J
440   STACKPTR(I)=I             'SET STACKPTR(I) TO LAST CARD IN EACH STACK
450   VISIPTR(I)=I              'SAME WITH VISIPTR(I)
460 NEXT I
470 DECKPTR=31:ENDDECK=52:DECK$(28)="   ":NC=24
480 DATA" AH"," 2H"," 3H"," 4H"," 5H"," 6H"," 7H"," 8H"," 9H","10H"," JH"," QH"," KH"
490 DATA" AD"," 2D"," 3D"," 4D"," 5D"," 6D"," 7D"," 8D"," 9D","10D"," JD"," QD"," KD"
500 DATA" AC"," 2C"," 3C"," 4C"," 5C"," 6C"," 7C"," 8C"," 9C","10C"," JC"," QC"," KC"
510 DATA" AS"," 2S"," 3S"," 4S"," 5S"," 6S"," 7S"," 8S"," 9S","10S"," JS"," QS"," KS"
520 FOR I=1 TO 7
530   STACK$(I,0)="   "
540 NEXT I
550 FOR I=1 TO 4
560   TOP$(I)="   "
570 NEXT I
580 RETURN
590 COLOR 3,1 :LOCATE 1,4:PRINT"TOP:":LOCATE 1,65:PRINT "Time: "
600 LOCATE 3,1:PRINT"STACKS:"
610 FOR I=7 TO 1 STEP -1
620   LOCATE  3,(45-(5*I))
630   PRINT I;
640 NEXT I
650 COLOR 7,1
660 FOR I=1 TO 7
670  FOR J=I TO 7
680     LOCATE (I+3),(45-(J*5))
690     IF VISIPTR(J)=I THEN C$=STACK$(J,I):GOSUB 2700:PRINT STACK$(J,I);:COLOR 7,1 ELSE FOR X=1 TO 3:PRINT CHR$(254);:NEXT X
700  NEXT J
710 NEXT I
720 COLOR 3,1
730 LOCATE 10 ,53:PRINT"PILE:";
740 COLOR 7,1
750 LOCATE 10,59:C$=DECK$(DECKPTR):GOSUB 2700:PRINT DECK$(DECKPTR);:COLOR 3,1:LOCATE 10,65:PRINT"Count: ";:COLOR 7:PRINT NC;:COLOR 3
760 LOCATE 11,64:PRINT"Card #: ";:COLOR 7:PRINT DECKPTR-28;"  ";
770 COLOR 3:LOCATE 12,50:PRINT"COMMAND: __  ";
780 COLOR 2
790 LOCATE 24,24:PRINT"Press F1 for a list of Commands";
800 COLOR 7
810 LOCATE 12,59
820 RETURN
830 SCREEN 0,1,1,0
840 CLS
850 LOCATE 10,10:PRINT"C    Claim Victory"
860 LOCATE 11,10:PRINT"N    New Card on Pile"
870 LOCATE 12,10:PRINT"P#   Card on Pile to Specified Stack"
880 LOCATE 13,10:PRINT"PT   Card on Pile to Top"
890 LOCATE 14,10:PRINT"##   Visible Cards on Stack to New Specified Stack"
900 LOCATE 15,10:PRINT"#T   Bottom Card on Specified Stack to Top"
910 LOCATE 16,10:PRINT"Q    Quit"
920 LOCATE 17,10:PRINT"F1   For This Screen"
930 COLOR 12:LOCATE 18,10:PRINT"Esc  Abort End and Return to Present Game
940 COLOR 2:LOCATE 22,28:PRINT"Press Any Key To Continue":COLOR 7
950 SCREEN 0,1,0,0
960 RETURN
970 SCREEN 0,1,0,1
980 A$=INKEY$:IF A$="" THEN 980 ELSE 950
990 FLAG=0:GOSUB 1660:IF FLAG=1 THEN 260
1000 LOCATE 12,59:PRINT"__  ";:LOCATE 12,59
1010 K$=INKEY$:IF K$="" THEN LOCATE 1,71:PRINT TIME$;:LOCATE 12,59:GOTO 1010 ELSE PRINT K$;
1020 IF K$="N" OR K$="n" THEN 1080
1030 IF K$="P" OR K$="p" THEN 1160
1040 IF K$>="1"AND K$<="7" THEN 1720
1050 IF K$="Q" OR K$="q" THEN FLAG=0:GOTO 260
1060 IF K$="C" OR K$="c" THEN  2470
1070 SOUND 50,5:GOTO 1000
1080 IF DECKPTR+3>ENDDECK THEN DECKPTR=28
1090 X=ENDDECK-28
1100 IF X <=3 THEN DECKPTR=ENDDECK ELSE DECKPTR=DECKPTR+3
1110 LOCATE 10,59
1120 C$=DECK$(DECKPTR):GOSUB 2700:PRINT DECK$(DECKPTR):COLOR 7,1
1130 LOCATE 11,72:PRINT DECKPTR-28;"  ";
1140 GOTO 1000
1150 K$=INKEY$:IF K$="" THEN 1150 ELSE PRINT K$;:RETURN
1160 GOSUB 1150
1170 IF(K$="t" OR K$="T") OR (K$>="1" AND K$<="7") THEN 1180 ELSE SOUND 50,5:GOTO 1000
1180 W$=DECK$(DECKPTR)
1190 SUIT$=MID$(W$,3,1):SIZE$=MID$(W$,2,1)
1200 IF K$="T" OR K$="t" THEN GOSUB 1380:GOTO 1280
1210 K=VAL(K$)
1220 W1$=STACK$(K,STACKPTR(K))
1230 SUITST$=MID$(W1$,3,1):SIZEST$=MID$(W1$,2,1)
1240 FLAG=0:GOSUB 1450:IF FLAG=0 THEN SOUND 50,5 :GOTO 990
1250 STACKPTR(K)=STACKPTR(K)+1
1260 STACK$(K,STACKPTR(K))=W$
1270 LOCATE STACKPTR(K)+3,(45-(K*5)):C$=W$:GOSUB 2700:PRINT W$:COLOR 7,1
1280 DECKPTR=DECKPTR-1:GOSUB 1320
1290 LOCATE 10,59:IF DECKPTR>28 THEN C$=DECK$(DECKPTR):GOSUB 2700:PRINT DECK$(DECKPTR):COLOR 7,1 ELSE PRINT"   "
1300 LOCATE 11,72:PRINT DECKPTR-28;"  ";
1310 GOTO 990
1320 IF DECKPTR+1=ENDDECK THEN 1360
1330 FOR I= DECKPTR+2 TO ENDDECK
1340 DECK$(I-1)=DECK$(I)
1350 NEXT I
1360 ENDDECK=ENDDECK-1:NC=NC-1:LOCATE 10,72:PRINT NC;
1370 RETURN
1380 IF SUIT$="C" THEN N=1:GOTO 1420
1390 IF SUIT$="D" THEN N=2:GOTO 1420
1400 IF SUIT$="H" THEN N=3:GOTO 1420
1410 N=4
1420 SIZEST$=MID$(TOP$(N),2,1)
1430 FLAG=0:GOSUB 1570:IF FLAG=0 THEN SOUND 50,5:GOTO 990
1440 TOP$(N)=W$:LOCATE 1,10+(10*(N-1)):C$=W$:GOSUB 2700:PRINT W$:COLOR 7,1:RETURN
1450 IF(SUIT$="H"OR SUIT$="D")AND(SUITST$="H"OR SUITST$="D") THEN RETURN
1460 IF(SUIT$="C"OR SUIT$="S")AND(SUITST$="C"OR SUITST$="S") THEN RETURN
1470 IF SIZE$>"9" THEN 1510
1480 IF SIZE$="0" AND SIZEST$="J" THEN 1560
1490 IF SIZE$="9" AND SIZEST$="0" THEN 1560
1500 IF (ASC(SIZEST$)-ASC(SIZE$))=1 THEN 1560
1510 IF SIZE$="A" AND SIZEST$="2" THEN 1560
1520 IF SIZE$="J" AND SIZEST$="Q" THEN 1560
1530 IF SIZE$="Q" AND SIZEST$="K" THEN 1560
1540 IF SIZE$="K" AND SIZEST$=" " THEN 1560
1550 RETURN
1560 FLAG=1:RETURN
1570 IF SIZE$="A" AND SIZEST$=" " THEN 1650
1580 IF SIZE$="2" AND SIZEST$="A" THEN 1650
1590 IF SIZE$="0" AND SIZEST$="9" THEN 1650
1600 IF (ASC(SIZE$)-ASC(SIZEST$))=1 THEN 1650
1610 IF SIZE$="J" AND SIZEST$="0" THEN 1650
1620 IF SIZE$="Q" AND SIZEST$="J" THEN 1650
1630 IF SIZE$="K" AND SIZEST$="Q" THEN 1650
1640 RETURN
1650 FLAG=1:RETURN
1660 REM  CHECK TO SEE IF THE GAME IS OVER
1670 FOR I=1 TO 4
1680 IF MID$(TOP$(I),2,1)<>"K" THEN RETURN
1690 NEXT I
1700 REM GAME OVER AND PLAYER WON
1710 FLAG=1:RETURN
1720 REM STACK TO STACK MOVE OR STACK TO TOP
1730 STKNUM1=VAL(K$)
1740 GOSUB 1150
1750 IF (K$>="1" AND K$<="7") OR (K$="T" OR K$="t") THEN 1770
1760 SOUND 50,5:GOTO 1000
1770 IF K$="t" OR K$="T" THEN W$=STACK$(STKNUM1,STACKPTR(STKNUM1)):GOTO 1790
1780 W$=STACK$(STKNUM1,VISIPTR(STKNUM1))
1790 SUIT$=MID$(W$,3,1)
1800 SIZE$=MID$(W$,2,1)
1810 IF K$="T" OR K$="t" THEN GOSUB 1380:GOTO 2040
1820 STKNUM2=VAL(K$)
1830 W$=STACK$(STKNUM2,STACKPTR(STKNUM2))
1840 SUITST$=MID$(W$,3,1)
1850 SIZEST$=MID$(W$,2,1)
1860 FLAG=0:GOSUB 1450
1870 IF FLAG=0 THEN SOUND 50,5:GOTO 1000
1880 IF VISIPTR(STKNUM1)=0 THEN VISIPTR(STKNUM1)=1
1890 FOR I=VISIPTR(STKNUM1) TO STACKPTR(STKNUM1)
1900 STACKPTR(STKNUM2)=STACKPTR(STKNUM2)+1
1910 LOCATE I+3,45-(STKNUM1*5):PRINT"   ";
1920 STACK$(STKNUM2,STACKPTR(STKNUM2))=STACK$(STKNUM1,I)
1930 LOCATE STACKPTR(STKNUM2)+3,45-(STKNUM2*5)
1940 C$ =  STACK$(STKNUM2,STACKPTR(STKNUM2)):GOSUB 2700
1950 PRINT STACK$(STKNUM2,STACKPTR(STKNUM2));:COLOR 7,1
1960 NEXT I
1970 IF VISIPTR(STKNUM1)>0 THEN VISIPTR(STKNUM1)=VISIPTR(STKNUM1)-1
1980 STACKPTR(STKNUM1)=VISIPTR(STKNUM1)
1990 IF STACKPTR(STKNUM1)<1 THEN 990
2000 LOCATE STACKPTR(STKNUM1)+3,45-(STKNUM1*5)
2010 C$ =  STACK$(STKNUM1,STACKPTR(STKNUM1)):GOSUB 2700
2020 PRINT STACK$(STKNUM1,STACKPTR(STKNUM1));:COLOR 7,1
2030 GOTO 990
2040 LOCATE STACKPTR(STKNUM1)+3,45-(STKNUM1*5)
2050 PRINT"   ";
2060 IF STACKPTR(STKNUM1)=VISIPTR(STKNUM1) THEN 1970
2070 STACKPTR(STKNUM1)=STACKPTR(STKNUM1)-1
2080 GOTO 990
2090 REM PRINT OUT THE TABLE
2100 COLOR 2 : SEEN = FALSE
2110 LOCATE 24,24:PRINT"Would you like to see the cards? "; :SOUND 1975,1:GOSUB 2580 : SOUND 1975,1
2120 A$=INKEY$:IF A$="" THEN 2120
2130 IF A$=CHR$(27) THEN ABORT=TRUE : LOCATE 24,24:PRINT SPACE$(40);:COLOR 7 : RETURN :ELSE ABORT=FALSE
2140 IF A$<>"y" AND A$<>"Y" AND A$<>"N" AND A$<>"n" THEN SOUND 50,5:GOTO 2120
2150 IF A$="N" OR A$="n" THEN 2320
2160 SEEN = TRUE : LOCATE 24,24:PRINT "                                    ";
2170 FOR I=7 TO 1 STEP -1
2180 X=1
2190 WHILE VISIPTR(I)>X
2200 LOCATE X+3,45-(I*5)
2210 PRINT STACK$(I,X);:X=X+1
2220 WEND
2230 NEXT I
2240 LOCATE 18,50:PRINT"Pile: "
2250 X=0:RR=18
2260 FOR I=29 TO ENDDECK
2270 IF X+56>76 THEN RR=RR+1:X=0
2280 LOCATE RR,X+56
2290 IF DECK$(I)="   "THEN 2320 ELSE PRINT DECK$(I);:X=X+4
2300 NEXT I
2310 COLOR 7
2320 RETURN
2330 COLOR 2
2340 IF SCR.WIDTH=40 THEN SCR.WIDTH =80:LOCATE 24,15:PRINT"Play Again?";:GOTO 2360 ELSE LOCATE 24,24
2350 LOCATE 24,24:PRINT"     Do you want to play again?                     ";
2360 A$=INKEY$:IF A$="" THEN 2360
2370 IF NOT WON THEN COLOR 7
2380 IF A$<>CHR$(27) THEN 2420 ELSE IF NOT SEEN AND NOT WON THEN ABORT=TRUE :LOCATE 24,28:PRINT SPACE$(30);:RETURN
2390 IF WON THEN SOUND 50,5: GOTO 2360
2400 SOUND 50,5:LOCATE 24,17:PRINT"Cheater... Shame Shame!  You've already seen the cards!";:DT!=2000:GOSUB 2600
2410 LOCATE 24,17 : PRINT SPACE$(60);:GOTO 2340
2420 IF A$="y" OR A$="Y" THEN GOSUB 2890:FLAG =1:RETURN
2430 IF A$="N" OR A$="n" THEN GOSUB 2890:RETURN
2440 SOUND 50,5:GOTO 2360
2450 GOSUB 2730
2460 RETURN
2470 'CHECK TO SEE IF CLAIMED VICTORY
2480 FLAG=0
2490 IF NC>0 THEN 2540
2500 FOR I=1 TO 7
2510 IF VISIPTR(I)>1 THEN 2540
2520 NEXT I
2530 FLAG=1:GOTO 260
2540 SOUND 50,5:LOCATE 14,50:PRINT"You Have Not Won Yet!!!"
2550 DT! = 2000 : GOSUB 2600
2560 LOCATE 14,50:PRINT SPC(25);
2570 GOTO 1000
2580 'DELAY TIME ROUTINE FOR (DT!) MILLISECONDS
2590 DT!=250
2600 DV!=DT!*18.2/1000
2610 DEF SEG = &H40
2620 WHILE DV!>0
2630    A! = O
2640    FOR ID = O TO 3
2650    A! = A!*256 + PEEK(&H6F-ID)
2660    NEXT ID
2670    IF A! <> AOLD! THEN DV! = DV! - 1 : AOLD! = A!
2680 WEND
2690 DEF SEG : RETURN
2700 C$=MID$(C$,3,1)
2710 IF C$="H" OR C$="D" THEN COLOR 12,7 ELSE COLOR 0,7
2720 RETURN
2730 REM 'DISPLAY WON SCREEN'
2740 IF NOT.READ THEN FOR I = 1 TO 82 : READ XYARR$(I) : NEXT : NOT.READ=FALSE
2750 SCREEN 1,0 : COLOR 1,0
2760 FOR I = 82 TO 1 STEP -1
2770 FOR J = 1 TO 45
2780 X=RND(1)*320:Y=RND(1)*200:C=C+1:IF C=4 THEN C=1
2790 PSET (X,Y),C
2800 NEXT J
2810 LL = INT(RND(1)*I)+1
2820 XYPOS$=XYARR$(LL)
2830 XYARR$(LL)=XYARR$(I)
2840 Y = VAL(LEFT$(XYPOS$,1))+8
2850 X= VAL(RIGHT$(XYPOS$,2))
2860 LOCATE Y,X:PRINT "*";
2870 NEXT I
2880 SCR.WIDTH=40 : WON = TRUE : RETURN
2890 SCREEN 0,0,0,0:WIDTH 80:RETURN
2900  DATA "002","006","009","010","011","014","018","023","027","030"
2910  DATA "031","032","035","039","103","105","108","112","114"
2920  DATA "118","123","127","129","133","135","136","139","204","208"
2930  DATA "212","214","218","223","225","227","229","233","235","236"
2940  DATA "237","239","304","308","312","314","318","323","325","327"
2950  DATA "329","333","335","337","338","339","404","408","412","414"
2960  DATA "418","423","425","427","429","433","435","438","439","504"
2970  DATA "509","510","511","515","516","517","524","526","530","531"
2980  DATA "532","535","539"
2990 'Last Line of SOLITAIR.BAS
