'Sphere program -- Chris Berry -- blackvoid13@hotmail.com

The problem is the program will only work well with one spinning sphere at a time (MAXSPHERES).
Try and make it so that it can spin atleast two sphers at a time adequately. I couldn't even
figure this out in the time that i had.

'Thanks for playing! E-mail me the solution to blackvoid13@hotmail.com

'http://www.geocities.com/Area51/Labyrinth/7661/basic.html

DEFINT A-Z
SCREEN 13

CONST MAXSPHERES = 1	'number of spinning spheres
CONST delay = 10000	'speed
CONST radius = 20	'radius of each sphere

CONST MAXX = 320	'max x (left) dimensions for the sphere to bounce in
CONST MAXY = 200	'max y (down) dimensions for the sphere to bounce in
CONST MINX = 0		'min x (right) dimensions for the sphere to bounce in
CONST MINY = 0		'min y (upper) dimensions for the sphere to bounce in

TYPE Index	
  x AS INTEGER
  y AS INTEGER
  M AS INTEGER
  D AS INTEGER
  a AS DOUBLE
END TYPE

DIM sphere(1 TO MAXSPHERES) AS Index	'put sphere into an array
DIM i AS INTEGER
DIM C AS INTEGER

D = 0: M = 0: C = 10

RANDOMIZE TIMER
FOR i = 1 TO MAXSPHERES		'give each sphere a random position
  sphere(i).x = INT(RND * (MAXX - MINX) + MINX)
  sphere(i).y = INT(RND * (MAXY - MINY) + MINY)
NEXT i

DO				'begin main code
  FOR i = 1 TO MAXSPHERES
    IF sphere(i).D = 0 THEN	'determine how to spin coin (like a coin)
      sphere(i).a = sphere(i).a - .2
      IF sphere(i).a < .3 THEN sphere(i).D = 1
    ELSEIF sphere(i).D = 1 THEN
      sphere(i).a = sphere(i).a + .2
      IF sphere(i).a > 3.9 THEN sphere(i).D = 0
    END IF

    IF sphere(i).M = 0 THEN	'this chunk of code allows it to bounce of walls properly
        sphere(i).x = sphere(i).x + 1: sphere(i).y = sphere(i).y + 1
          IF sphere(i).y > MAXY THEN sphere(i).M = 1
          IF sphere(i).x > MAXX THEN sphere(i).M = 3
      ELSEIF sphere(i).M = 1 THEN
        sphere(i).x = sphere(i).x + 1: sphere(i).y = sphere(i).y - 1
          IF sphere(i).y < MINY THEN sphere(i).M = 0
          IF sphere(i).x > MAXX THEN sphere(i).M = 2
      ELSEIF sphere(i).M = 2 THEN
        sphere(i).x = sphere(i).x - 1: sphere(i).y = sphere(i).y - 1
          IF sphere(i).y < MINY THEN sphere(i).M = 3
          IF sphere(i).x < MINX THEN sphere(i).M = 1
      ELSEIF sphere(i).M = 3 THEN
        sphere(i).x = sphere(i).x - 1: sphere(i).y = sphere(i).y + 1
          IF sphere(i).y > MAXY THEN sphere(i).M = 2
          IF sphere(i).x < MINX THEN sphere(i).M = 0
    END IF
  C = C + 1: IF C > 63 THEN C = 10			
  OUT &H3C8, C: OUT &H3C9, 0: OUT &H3C9, C: OUT &H3C9, 0	'cool shaded green colors
  CIRCLE (sphere(i).x, sphere(i).y), radius, C, , , 4 / sphere(i).a	'draw circle
    FOR s = 1 TO delay: NEXT s
  CIRCLE (sphere(i).x, sphere(i).y), radius, 0, , , 4 / sphere(i).a	'mask old circle
  NEXT i
LOOP		'here we go loop de loop

