'2d texture zoom/rotation demo
'seriously fast now 30+ fps on Pentium
'by Toshihiro Horie
'toshiman@uclink4.berkeley.edu
DEFINT A-Z
'possible modifications:
'3) reverse rotation mapping
xh = 40: yh = 30: ch = 16
CONST xmax = 320, ymax = 200
xd = 160: yd = 100
v = 0: w = 1
DIM C(360): DIM S(360)
'set up sinus tables
deg2rad# = .01745329#
PRINT "Calculating sinus tables..."
FOR t = 0 TO 179
    C(t) = COS(t * deg2rad#) * 128
    S(t) = SIN(t * deg2rad#) * 128
NEXT
FOR t = 180 TO 359
    S(t) = -S(t - 180)
    C(t) = C(360 - t)
NEXT


SCREEN 7, , v, w
'plot some points in a box
'LINE (0, 0)-(xh, yh), 15, B
DIM block(xh, yh)
FOR t = 1 TO 100
    x = INT(RND * xh): y = INT(RND * yh)
    C = INT(RND * ch)
    'PSET (x, y), C
    block(x, y) = C
NEXT

'rotate it about its center
z = 3: num = 1: st = 121: '1/3 of 360 + dtheta of 1 deg
aaa = 128
bbb = 412: 'skew x
ccc = 128
ddd = 128

NumberOfFrames = 0
DEF SEG = &H40
StartTime = PEEK(&H6C)
DO
    FOR w = 1 TO 3
    a = (a + st) MOD 360
    k$ = INKEY$
    IF k$ = CHR$(27) THEN END
    IF z > 8 THEN z = 8
    IF z < -8 THEN z = -8
    Ca = C(a)
    Sa = S(a)
    FOR x = 0 TO xh
    xo = (x - xh \ 2)
    FOR y = 0 TO yh
        IF block(x, y) = 0 THEN GOTO skip
        yo = (y - yh \ 2)
        xp = xo * Ca * z \ aaa - yo * Sa * z \ bbb
        yp = yo * Ca * z \ ccc + xo * Sa * z \ ddd
        PSET (xp + xd, yd - yp), block(x, y)
skip:
    NEXT: NEXT: NEXT
    
    SWAP v, w: SCREEN 7, , v, w:  WAIT &H3DA, 8
    LINE (0, 30)-(xmax, ymax), 0, BF
LOOP

