'===========================================================================
' Subject: TOGGLE COLOR BLINKING ON/OFF       Date: 05-04-95 (16:29)       
'  Author: Len Philpot                        Code: QB, PDS                
'  Origin: FidoNet QUIK_BAS Echo            Packet: MISC.ABC
'===========================================================================
'* I found an OUT statement awhile back, that would turn off blinking on
'* the machine.  But it doesn't work.  In the QB Options, Colors menu, you

'There's an interrupt call that will toggle between blinking foreground 
'and high-intensity background colors. The following is a very simple 
'little program I wrote to toggle it back and forth.

DEFINT A-Z

'$INCLUDE: 'qb.bi'

   DIM InRegs AS RegType, OutRegs AS RegType

   IF COMMAND$ = "ON" THEN
        InRegs.BX = 1                  '*
     ELSEIF COMMAND$ = "OFF" THEN
        InRegs.BX = 0                  '*
      ELSE
        PRINT "Usage:  BLINK on (enables blinking FG and disables bright BG colors)"
        PRINT "        BLINK off (disables blinking FG and enables bright BG colors)"
      END
   END IF
    InRegs.AX = &H1003                 '*
    Interrupt &H10, InRegs, OutRegs    '*
   PRINT

'The lines commented with an asterisk are what you're looking for. Call 
'BIOS interrupt 10h, sub function 1003h. Set bx to 1 to blink, 0 to 
'disable it.
