' Speed 2

' by Rgis Locas

'

' You're a line, and your objective is to make other lines bump in you while

' avoiding them too.

'

' You can play up to 4 at a time, humans or computers. The computers aren't

' quite good. Maybe I'll work on it later...maybe not.

'

' The controls are explained when you select 'Begin Game'

'

' Deadly explosions kill people who bump in them.

' Game speed affects the game speed (1-fast, 5-slow)

' 3D effect length makes the walls nicer...

'

' Computer difficulty simply determines how many pixels computers look ahead.

'

' Enjoy!

'

' For those who are wondering, Speed 1 was about the same game, but with

' unreal-time explosions. This made the game quite difficult to be playable

' by more than 2 players. Also, the gaming engine was lex flexible, and a

' whole rewrite was necessary to add more players and options. Speed 2 is

' that whole rewrite.

RANDOMIZE TIMER

SCREEN 7

DEFINT A-Z

DIM x(1 TO 4)

DIM y(1 TO 4)

DIM playerType(1 TO 4)

DIM score(1 TO 4)

DIM direction(1 TO 4)

DIM pColors(1 TO 4)

DIM p3D(1 TO 4)

DIM pTypes$(0 TO 2)

DIM mKeys$(1 TO 4, 1 TO 4)

DIM exploX(1 TO 4): DIM exploY(1 TO 4)

DIM exploSeq(1 TO 4)

LINE (0, 0)-(319, 199), 7, BF

LINE (0, 0)-(317, 197), 15, B

LINE (2, 2)-(319, 199), 8, B

LINE (1, 1)-(318, 198), 7, B

LINE (3, 3)-(316, 196), 0, BF

mKeys$(1, 1) = CHR$(0) + CHR$(80) ' Down

mKeys$(1, 2) = CHR$(0) + CHR$(77) ' Right

mKeys$(1, 3) = CHR$(0) + CHR$(75) ' Left

mKeys$(1, 4) = CHR$(0) + CHR$(72) ' Up

mKeys$(2, 1) = "2"                ' Down

mKeys$(2, 2) = "6"                ' Right

mKeys$(2, 3) = "4"                ' Left

mKeys$(2, 4) = "8"                ' Up

mKeys$(3, 1) = "S"                ' Down

mKeys$(3, 2) = "D"                ' Right

mKeys$(3, 3) = "A"                ' Left

mKeys$(3, 4) = "W"                ' Up

mKeys$(4, 1) = "K"                ' Down

mKeys$(4, 2) = "L"                ' Right

mKeys$(4, 3) = "J"                ' Left

mKeys$(4, 4) = "I"                ' Up

playerType(1) = 1

playerType(2) = 2

pTypes$(0) = "None"

pTypes$(1) = "Human"

pTypes$(2) = "Computer"

eff3D = 2

gameSpeed = 1

deadlyExplosions! = 0

pColors(1) = 15: p3D(1) = 7

pColors(2) = 12: p3D(2) = 4

pColors(3) = 9: p3D(3) = 1

pColors(4) = 10: p3D(4) = 2

PALETTE 3, 12

FOR I = 0 TO 15

  SOUND 10000 - (I * 600), .5

  LOCATE 2, 2: PRINT SPACE$(I) + "Speed 2"

  LINE (314, 5)-(314 - I% * 20.57, 5), 9

  LINE (5, 18)-(5 + I% * 20.57, 18), 12

NEXT

SOUND 1000, 5

SLEEP 1

FOR c = 1 TO 3

  SOUND 370 * c, 1

  IF c = 1 THEN COLOR 8 ELSE IF c = 2 THEN COLOR 7 ELSE COLOR 15

  LOCATE 6, 8: PRINT "Player 1: Human"

  LOCATE 8, 8: PRINT "Player 2: Computer"

  LOCATE 10, 8: PRINT "Player 3: None"

  LOCATE 12, 8: PRINT "Player 4: None"

  LOCATE 14, 8: PRINT "3D effect length: 2"

  LOCATE 16, 8: PRINT "Game speed: 1"

  LOCATE 18, 8: PRINT "Deadly explosions: Off"

  LOCATE 20, 8: PRINT "Begin game!"

  LOCATE 22, 8: PRINT "Quit"

NEXT

xMenu = 1

LINE (43, 38)-(272, 49), 14, B

getMenu:

DO

  a$ = INKEY$

LOOP UNTIL a$ <> ""

LINE (43, 38 + (xMenu - 1) * 16)-(272, 49 + (xMenu - 1) * 16), 0, B

IF a$ = CHR$(0) + CHR$(72) THEN

  xMenu = xMenu - 1

  IF xMenu = 0 THEN xMenu = 9

  SOUND 400, .3

  SOUND 500, .3

  SOUND 300, .3

END IF

IF a$ = CHR$(0) + CHR$(80) THEN

  xMenu = xMenu + 1

  IF xMenu = 10 THEN xMenu = 1

  SOUND 400, .3

  SOUND 500, .3

  SOUND 300, .3

END IF

IF a$ = CHR$(13) THEN

  SOUND 500, .5

  SOUND 1000, .5

  SOUND 1500, .5

  IF xMenu > 0 AND xMenu < 5 THEN

    playerType(xMenu) = playerType(xMenu) + 1

    IF playerType(xMenu) = 3 THEN playerType(xMenu) = 0

    LOCATE 6, 8: PRINT "Player 1: "; pTypes$(playerType(1)); SPACE$(4)

    LOCATE 8, 8: PRINT "Player 2: "; pTypes$(playerType(2)); SPACE$(4)

    LOCATE 10, 8: PRINT "Player 3: "; pTypes$(playerType(3)); SPACE$(4)

    LOCATE 12, 8: PRINT "Player 4: "; pTypes$(playerType(4)); SPACE$(4)

  END IF

  IF xMenu = 5 THEN

    eff3D = eff3D + 1

    IF eff3D = 5 THEN eff3D = 0

    LOCATE 14, 8: PRINT "3D effect length:"; eff3D

  END IF

  IF xMenu = 6 THEN

    gameSpeed = gameSpeed + 1

    IF gameSpeed = 6 THEN gameSpeed = 1

    LOCATE 16, 8: PRINT "Game speed:"; gameSpeed

  END IF

  IF xMenu = 7 THEN

    deadlyExplosions! = NOT deadlyExplosions!

    IF NOT deadlyExplosions! THEN

      LOCATE 18, 8: PRINT "Deadly explosions: Off"

    ELSE

      LOCATE 18, 8: PRINT "Deadly explosions: On "

    END IF

  END IF

  IF xMenu = 8 THEN

    okToPlay = 0

    FOR I = 1 TO 4

      IF playerType(I) <> 0 THEN okToPlay = okToPlay + 1

    NEXT I

    IF okToPlay >= 2 THEN GOTO prepareGame

    PLAY "MS O0 L16 N0 L32 C L16 C"

  END IF

  IF xMenu = 9 THEN SYSTEM

END IF

LINE (43, 38 + (xMenu - 1) * 16)-(272, 49 + (xMenu - 1) * 16), 14, B

GOTO getMenu

prepareGame:

FOR c = 3 TO 1 STEP -1

  SOUND 370 * c, 1

  IF c = 1 THEN COLOR 0 ELSE IF c = 2 THEN COLOR 8 ELSE COLOR 7

  LOCATE 6, 8: PRINT "Player 1: "; pTypes$(playerType(1)); SPACE$(4)

  LOCATE 8, 8: PRINT "Player 2: "; pTypes$(playerType(2)); SPACE$(4)

  LOCATE 10, 8: PRINT "Player 3: "; pTypes$(playerType(3)); SPACE$(4)

  LOCATE 12, 8: PRINT "Player 4: "; pTypes$(playerType(4)); SPACE$(4)

  LOCATE 14, 8: PRINT "3D effect length:"; eff3D

  LOCATE 16, 8: PRINT "Game speed:"; gameSpeed

  IF NOT deadlyExplosions! THEN

    LOCATE 18, 8: PRINT "Deadly explosions: Off"

  ELSE

    LOCATE 18, 8: PRINT "Deadly explosions: On "

  END IF

  LOCATE 20, 8: PRINT "Begin game!"

  LOCATE 22, 8: PRINT "Quit"

NEXT

COLOR 15

LOCATE 6, 8: PRINT "Quick reminder..."

LOCATE 8, 10: PRINT "Player 1  Arrow keys"

LOCATE 10, 10: PRINT "Player 2  Keypad (Num Lock on)"

LOCATE 12, 10: PRINT "Player 3  W, A, S and D"

LOCATE 14, 10: PRINT "Player 4  I, J, K and L"

FOR c = 1 TO 4

  COLOR pColors(c)

  LOCATE 6 + (c * 2), 8: PRINT ""

NEXT

COLOR 15

LOCATE 18, 8: PRINT "Enter CPU difficulty (1-5)"

DO: a$ = INKEY$: LOOP UNTIL VAL(a$) > 0 AND VAL(a$) < 6

difficulty = VAL(a$)

IF deadlyExplosions! = 0 THEN exCol = 4 ELSE exCol = 3



startGame:

GOSUB initLocs

GOSUB drawArena

GOSUB printScores

eog! = 0

DO

  a$ = UCASE$(INKEY$)

  FOR player = 1 TO 4

    IF x(player) = 0 THEN GOTO passPlayer

    IF playerType(player) = 1 THEN

      IF a$ = mKeys$(player, 1) AND direction(player) <> 8 THEN

	direction(player) = 2

	SOUND 4000 - (player * 500), 1

      END IF

      IF a$ = mKeys$(player, 2) AND direction(player) <> 4 THEN

	direction(player) = 6

	SOUND 4000 - (player * 500), 1

      END IF

      IF a$ = mKeys$(player, 3) AND direction(player) <> 6 THEN

	direction(player) = 4

	SOUND 4000 - (player * 500), 1

      END IF

      IF a$ = mKeys$(player, 4) AND direction(player) <> 2 THEN

	direction(player) = 8

	SOUND 4000 - (player * 500), 1

      END IF

    ELSE

      GOSUB AI

    END IF

    IF direction(player) = 8 THEN y(player) = y(player) - 1

    IF direction(player) = 2 THEN y(player) = y(player) + 1

    IF direction(player) = 4 THEN x(player) = x(player) - 1

    IF direction(player) = 6 THEN x(player) = x(player) + 1

passPlayer:

  NEXT player

  FOR I = 1 TO 4

    IF x(I) = 0 THEN GOTO passPixel

    IF POINT(x(I), y(I)) = pColors(1) OR POINT(x(I), y(I)) = pColors(2) OR POINT(x(I), y(I)) = pColors(3) OR POINT(x(I), y(I)) = pColors(4) OR POINT(x(I), y(I)) = exCol THEN

      exploSeq(I) = 1

      exploX(I) = x(I)

      exploY(I) = y(I)

      PLAY "MB MS O0 L64 BAGFEDC"

    END IF

    PSET (x(I), y(I)), pColors(I)

    stop3D = 0

    FOR td = 1 TO eff3D

      IF POINT(x(I) + td, y(I) + td) = pColors(1) OR POINT(x(I) + td, y(I) + td) = pColors(2) OR POINT(x(I) + td, y(I) + td) = pColors(3) OR POINT(x(I) + td, y(I) + td) = pColors(4) THEN

	stop3D = 1

      END IF

      IF stop3D = 0 THEN

	PSET (x(I) + td, y(I) + td), p3D(I)

      END IF

    NEXT td

passPixel:

    IF exploSeq(I) <> 0 THEN

      x(I) = 0

      CIRCLE (exploX(I), exploY(I)), exploSeq(I) - 1, 0

      PAINT (exploX(I), exploY(I)), 0, 0

      CIRCLE (exploX(I), exploY(I)), exploSeq(I), 3

      PAINT (exploX(I), exploY(I)), 3, 3

      exploSeq(I) = exploSeq(I) + 1

      IF exploSeq(I) = 21 THEN

	CIRCLE (exploX(I), exploY(I)), exploSeq(I) - 1, 0

	PAINT (exploX(I), exploY(I)), 0, 0

	exploSeq(I) = 0

	LINE (0, 8)-(319, 199), 8, B

	LINE (1, 9)-(318, 198), 7, B

	LINE (2, 10)-(317, 197), 15, B

	FOR sc = 1 TO 4

	  IF x(sc) <> 0 THEN

	    score(sc) = score(sc) + 1

	  END IF

	NEXT

	GOSUB printScores

	gte = 0

	FOR ending = 1 TO 4

	  IF x(ending) <> 0 THEN gte = gte + 1

	NEXT

	IF gte = 1 OR gte = 0 THEN eog! = 1

      END IF

    END IF

  NEXT

  FOR spd = 1 TO (gameSpeed - 1) * 100: NEXT

LOOP UNTIL eog! = 1

GOSUB drawArena

GOSUB printScores

FOR exReset = 1 TO 4

  exploSeq(exReset) = 0

NEXT

IF gte = 0 THEN

  COLOR 7

  LOCATE 10, 11: PRINT "The match was a draw!"

  COLOR 15

  LOCATE 12, 13: PRINT "Play again? (Y/N)"

  DO: a$ = UCASE$(INKEY$): LOOP UNTIL a$ = "Y" OR a$ = "N"

  IF a$ = "Y" THEN GOTO startGame

ELSE

  gte = 0

  FOR player = 1 TO 4

    IF x(player) <> 0 THEN winner = player

  NEXT

  COLOR pColors(winner)

  LOCATE 10, 10: PRINT "Player"; winner; " won the match!"

  COLOR 15

  LOCATE 12, 13: PRINT "Play again? (Y/N)"

  DO: a$ = UCASE$(INKEY$): LOOP UNTIL a$ = "Y" OR a$ = "N"

  IF a$ = "Y" THEN GOTO startGame

END IF

RUN

END



AI:

  skipLook = 0

  lx = x(player)

  ly = y(player)

  FOR look = 1 TO difficulty

    IF skipLook = 1 THEN GOTO skipL

    IF direction(player) = 8 THEN ly = ly - 1

    IF direction(player) = 2 THEN ly = ly + 1

    IF direction(player) = 4 THEN lx = lx - 1

    IF direction(player) = 6 THEN lx = lx + 1

    IF POINT(lx, ly) = pColors(1) OR POINT(lx, ly) = pColors(2) OR POINT(lx, ly) = pColors(3) OR POINT(lx, ly) = pColors(4) OR POINT(lx, ly) = exCol THEN

      IF x(player) < 159 THEN prefH = 6 ELSE prefH = 4

      IF y(player) < 99 THEN prefV = 2 ELSE prefV = 8

      IF direction(player) = 8 OR direction(player) = 2 THEN

	IF prefH = 6 THEN

	  FOR ls = 1 TO 2

	    IF POINT(x(player) + ls, y(player)) = pColors(1) OR POINT(x(player) + ls, y(player)) = pColors(2) OR POINT(x(player) + ls, y(player)) = pColors(3) OR POINT(x(player) + ls, y(player)) = pColors(4) OR POINT(x(player) + ls, y(player)) = exCol THEN

	      prefH = 4

	    END IF

	  NEXT

	ELSE

	  FOR ls = -1 TO -2

	    IF POINT(x(player) + ls, y(player)) = pColors(1) OR POINT(x(player) + ls, y(player)) = pColors(2) OR POINT(x(player) + ls, y(player)) = pColors(3) OR POINT(x(player) + ls, y(player)) = pColors(4) OR POINT(x(player) + ls, y(player)) = exCol THEN

	      prefH = 6

	    END IF

	  NEXT

	END IF

	direction(player) = prefH

	skipLook = 1

	SOUND 4000 - (player * 500), 1

      ELSE

	IF prefV = 2 THEN

	  FOR ls = 1 TO 2

	    IF POINT(x(player), y(player) + ls) = pColors(1) OR POINT(x(player), y(player) + ls) = pColors(2) OR POINT(x(player), y(player) + ls) = pColors(3) OR POINT(x(player), y(player) + ls) = pColors(4) OR POINT(x(player), y(player) + ls) = exCol THEN

	      prefV = 8

	    END IF

	  NEXT

	ELSE

	  FOR ls = -1 TO -2

	    IF POINT(x(player), y(player) + ls) = pColors(1) OR POINT(x(player), y(player) + ls) = pColors(2) OR POINT(x(player), y(player) + ls) = pColors(3) OR POINT(x(player), y(player) + ls) = pColors(4) OR POINT(x(player), y(player) + ls) = exCol THEN

	      prefV = 2

	    END IF

	  NEXT

	END IF

	direction(player) = prefV

	skipLook = 1

	SOUND 4000 - (player * 500), 1

      END IF

    END IF

skipL:

  NEXT

RETURN



initLocs:

  IF playerType(1) <> 0 THEN

    x(1) = 7: y(1) = 15

    direction(1) = 6

  END IF

  IF playerType(2) <> 0 THEN

    x(2) = 312: y(2) = 192

    direction(2) = 4

  END IF

  IF playerType(3) <> 0 THEN

    x(3) = 312: y(3) = 15

    direction(3) = 2

  END IF

  IF playerType(4) <> 0 THEN

    x(4) = 7: y(4) = 192

    direction(4) = 8

  END IF

RETURN



printScores:

  LOCATE 1: PRINT SPACE$(40)

  FOR it = 1 TO 4

    LOCATE 1, (10 * (it - 1)) + 1

    IF playerType(it) = 0 OR x(it) = 0 THEN

      COLOR 7: PRINT "P" + RIGHT$(STR$(it), 1) + ":" + STR$(score(it))

    ELSE

      COLOR pColors(it): PRINT "P" + RIGHT$(STR$(it), 1) + ":" + STR$(score(it))

    END IF

  NEXT it

RETURN



drawArena:

  LINE (0, 8)-(319, 199), 8, B

  LINE (1, 9)-(318, 198), 7, B

  LINE (2, 10)-(317, 197), 15, B

  LINE (3, 11)-(316, 196), 0, BF

  FOR grid = 1 TO 16

    LINE (3, 10 + grid * 11)-(316, 10 + grid * 11), 1

  NEXT grid

  FOR grid = 1 TO 34

    LINE (2 + grid * 9, 11)-(2 + grid * 9, 196), 1

  NEXT grid

RETURN



