'Display a fullscreen random 3d map    - by mylemans
'
'Please visit my website: http://members.xoom.com/Myleman
'And mail your codes to: mylemans@yahoo.com
'
'QB startup: QB /L QB.QLB /AH RENDER.BAS

'$DYNAMIC
DECLARE SUB Copy (Xpos, Ypos, Action)
DECLARE SUB Smooth ()
DECLARE SUB Setpal ()
DECLARE SUB Plasm ()
DECLARE SUB Render ()
DECLARE SUB Altitude ()
DECLARE SUB Interface ()
DECLARE SUB SineText ()
DECLARE SUB AlphaPlasm ()
DECLARE SUB DrawIF ()
DECLARE SUB Mirror (Dir)
DECLARE SUB MouseStatus ()
DECLARE SUB CheckMouse ()

COMMON SHARED Xmouse%, Ymouse%, Lbutton%, Rbutton%, Mouse$, FirstMove
COMMON SHARED OldTXmouse, OldTYmouse, i$
COMMON SHARED Colval1, Colval2, Smoothing, Contrast, WaterLevel
COMMON SHARED MtSize, Scale, Yoffset, Bypass, Shading, Hoffset

DIM SHARED Image1(0 TO 199) AS STRING * 320
DIM SHARED Image2(0 TO 39) AS STRING * 64
DIM SHARED Mbuffer(16)

Smoothing = 0
Scale = 2
Yoffset = 50
WaterLevel = 140
Contrast = 1.9
MtSize = 8
Bypass = 0
Hoffset = -70

SCREEN 13

RANDOMIZE TIMER

Mouse$ = SPACE$(57)
FOR i% = 1 TO 57
READ A$
H$ = CHR$(VAL("&H" + A$))
MID$(Mouse$, i%, 1) = H$
NEXT i%

DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

DO
Interface
LOOP

REM $STATIC
SUB AlphaPlasm

CLS

FOR pp = 0 TO 255
PALETTE pp, INT(pp / 4) + INT(pp / 4) * 256 + INT(pp / 4) * 65536
NEXT

FOR Xpos = 0 TO 319
FOR Ypos = 0 TO 199
Copy Xpos, Ypos, 3
IF Colval1 <= WaterLevel THEN
        PSET (Xpos, Ypos), WaterLevel
        ELSE PSET (Xpos, Ypos), Colval1
        END IF
NEXT: NEXT

SOUND 1000, 1

DO: LOOP UNTIL INKEY$ <> ""

CLS

Setpal
PALETTE WaterLevel, 65536 * 45
FOR x = 1 TO WaterLevel
PALETTE x, 65536 * INT(x / (WaterLevel / 63))
NEXT

END SUB

SUB Altitude

FOR x = 0 TO 319
FOR y = 0 TO 199
IF POINT(x, y) > 0 AND (POINT(x, y) * Contrast) + Hoffset < 255 THEN
        PSET (x, y), (POINT(x, y) * Contrast) + Hoffset
        ELSE PSET (x, y), 255
        END IF
NEXT: NEXT

END SUB

SUB CheckMouse

MouseStatus
TXmouse = INT(Xmouse% / 16)
TYmouse = INT(Ymouse% / 8)

IF TXmouse <> OldTXmouse OR TYmouse <> OldTYmouse THEN
        IF FirstMove = 0 THEN
                FirstMove = 1
                ELSE PUT (OldTXmouse * 8, OldTYmouse * 8), Mbuffer, PSET
                END IF
        GET (TXmouse * 8, TYmouse * 8)-(TXmouse * 8 + 7, TYmouse * 8 + 7), Mbuffer
        FOR x = 0 TO 7
        FOR y = 0 TO 7
        PSET (TXmouse * 8 + x, TYmouse * 8 + y), POINT(TXmouse * 8 + x, TYmouse * 8 + y) - (x + 1) * (y + 1)
        NEXT: NEXT
        END IF

OldTXmouse = TXmouse
OldTYmouse = TYmouse

IF Lbutton% OR Rbutton% THEN
        IF TXmouse < 15 THEN
                IF TYmouse = 1 THEN i$ = "S"
                IF TYmouse = 3 THEN i$ = "H"
                IF TYmouse = 5 THEN i$ = "W"
                IF TYmouse = 7 THEN i$ = "M"
                IF TYmouse = 9 THEN i$ = "O"
                IF TYmouse = 13 THEN i$ = "C"
                IF TYmouse = 15 THEN i$ = "V"
                IF TYmouse = 17 THEN i$ = "B"
                END IF
        IF TXmouse > 27 THEN
                IF TYmouse = 1 THEN i$ = "P"
                IF TYmouse = 3 THEN i$ = "E"
                IF TYmouse = 5 THEN i$ = "L"
                IF TYmouse = 7 THEN i$ = "F"
                IF TYmouse = 9 THEN i$ = "I"
                IF TYmouse = 13 THEN i$ = "R"
                IF TYmouse = 15 THEN i$ = "A"
                END IF
        END IF

END SUB

SUB Copy (Xpos, Ypos, Action)

IF Action = 0 THEN MID$(Image1(Ypos), Xpos + 1) = CHR$(POINT(Xpos, Ypos))

IF Action = 1 THEN MID$(Image2(Ypos), Xpos + 1) = CHR$(POINT(Xpos * 5, Ypos * 5))

IF Action = 2 THEN Colval1 = ASC(MID$(Image2(Ypos), Xpos + 1, 1))

IF Action = 3 THEN
        Colval1 = ASC(MID$(Image1(Ypos), Xpos + 1, 1))
        IF Ypos < 199 THEN
        Colval2 = ASC(MID$(Image1(Ypos + 1), Xpos + 1, 1))
        ELSE Colval2 = Colval1
        END IF
        IF ABS(Colval1 - Colval2) > 15 THEN Colval2 = Colval1 - 15
        END IF

IF Action = 4 THEN
        FOR Xpos = 0 TO 63
        FOR Ypos = 0 TO 39
        MID$(Image2(Ypos), Xpos + 1) = CHR$(0)
        NEXT: NEXT
        END IF

END SUB

SUB DrawIF

CLS

FOR x = 0 TO 319
PSET (x, 0), (319 - x) / 319 * WaterLevel
PSET (x, 2), x / 319 * WaterLevel
PSET (x, 90), (319 - x) / 319 * WaterLevel
PSET (x, 92), x / 319 * WaterLevel
PSET (x, 154), (319 - x) / 319 * WaterLevel
PSET (x, 156), x / 319 * WaterLevel
PSET (210, x / 319 * 156), x / 319 * WaterLevel
PSET (212, x / 319 * 156), (319 - x) / 319 * WaterLevel
NEXT

FOR x = 0 TO 63 STEP .5
LINE (11 + x * 2, 160)-(11 + x * 2, 168), x
LINE (11 + x * 2, 170)-(11 + x * 2, 178), 127 - x
LINE (11 + x * 2, 180)-(11 + x * 2, 188), 128 + x
LINE (11 + x * 2, 190)-(11 + x * 2, 198), 255 - x
NEXT

FOR x = 1 TO 11
CIRCLE (138, 169), x, 63, 4.71, 1.57
CIRCLE (139, 169), x, 63, 4.71, 1.57
CIRCLE (11, 179), x, 127, 1.57, 4.71
CIRCLE (10, 179), x, 127, 1.57, 4.71
CIRCLE (138, 189), x, 191, 4.71, 1.57
CIRCLE (139, 189), x, 191, 4.71, 1.57
NEXT

FOR Xpos = 0 TO 319 STEP 5
FOR Ypos = 0 TO 199 STEP 5
Copy Xpos, Ypos, 3
PSET (254 + Xpos / 5, 160 + Ypos / 5), Colval1
Copy Xpos / 5, Ypos / 5, 2
PSET (175 + Xpos / 5, 160 + Ypos / 5), Colval1
NEXT: NEXT

COLOR 250
LOCATE 2, 2: PRINT "moothing :"; Smoothing
LOCATE 4, 2: PRINT "eight Contrast :"; Contrast
LOCATE 6, 2: PRINT "aterlevel :"; WaterLevel
LOCATE 8, 2: PRINT "ountainsize :"; MtSize
LOCATE 10, 1: PRINT "Height  ffset :"; Hoffset
LOCATE 14, 1: PRINT "S ale :"; Scale
LOCATE 16, 2: PRINT "ertical Offset :"; Yoffset
LOCATE 18, 2: PRINT "ypass :"; Bypass
LOCATE 2, 30: PRINT "Draw  lasma"
LOCATE 4, 30: PRINT "Vi w Plasma"
LOCATE 6, 31: PRINT "View A pha"
LOCATE 14, 33: PRINT "ender 3D"
LOCATE 16, 29: PRINT "Render  lpha"
LOCATE 8, 36: PRINT "lip H"
LOCATE 10, 35: PRINT "Fl p V"

IF WaterLevel < 250 THEN
        COLOR WaterLevel + 5
        ELSE COLOR 1
        END IF
LOCATE 2, 1: PRINT "S"
LOCATE 4, 1: PRINT "H"
LOCATE 6, 1: PRINT "W"
LOCATE 8, 1: PRINT "M"
LOCATE 14, 2: PRINT "c"
LOCATE 16, 1: PRINT "V"
LOCATE 18, 1: PRINT "B"
LOCATE 2, 35: PRINT "P"
LOCATE 14, 32: PRINT "R"
LOCATE 16, 36: PRINT "A"
LOCATE 4, 32: PRINT "e"
LOCATE 6, 37: PRINT "l"
LOCATE 10, 8: PRINT "O"
LOCATE 8, 35: PRINT "F"
LOCATE 10, 37: PRINT "i"

COLOR 255

END SUB

SUB Interface

CLS
Setpal
PALETTE WaterLevel, 65536 * 45
FOR x = 1 TO WaterLevel
PALETTE x, 65536 * INT(x / (WaterLevel / 63))
NEXT

20 DrawIF

DO
i$ = INKEY$
CheckMouse
IF i$ <> "" THEN
        IF i$ = "s" OR i$ = "S" THEN
                LOCATE 2, 1: INPUT "Smoothing (0 - 20):"; Smoothing
                IF Smoothing < 0 OR Smoothing > 20 THEN Smoothing = 0
        END IF
        IF i$ = "h" OR i$ = "H" THEN
                LOCATE 4, 1: INPUT "Height Contrast (.5 - 3):"; Contrast
                IF Contrast < .5 OR Contrast > 3 THEN Contrast = 1.9
                END IF
        IF i$ = "w" OR i$ = "W" THEN
                LOCATE 6, 1: INPUT "Waterlevel (0 - 255):"; WaterLevel
                IF WaterLevel < 0 OR WaterLevel > 255 THEN WaterLevel = 140
                Setpal
                PALETTE WaterLevel, 65536 * 45
                FOR x = 1 TO WaterLevel
                PALETTE x, 65536 * INT(x / (WaterLevel / 63))
                NEXT
                Copy 0, 0, 4
                END IF
        IF i$ = "m" OR i$ = "M" THEN
                LOCATE 8, 1: INPUT "Mountainsize (1 - 20):"; MtSize
                IF MtSize < 1 OR MtSize > 20 THEN MtSize = 8
                END IF
        IF i$ = "c" OR i$ = "C" THEN
                LOCATE 14, 1: INPUT "Scale (1-30):"; Scale
                IF Scale < 1 OR Scale > 30 THEN Scale = 2
                END IF
        IF i$ = "v" OR i$ = "V" THEN
                LOCATE 16, 1: INPUT "Vertical Offset (0-150):"; Yoffset
                IF Yoffset < 0 OR Yoffset > 150 THEN Yoffset = 50
                END IF
        IF i$ = "b" OR i$ = "B" THEN
                LOCATE 18, 1: INPUT "Bypass (0-30):"; Bypass
                IF Bypass < 0 OR Bypass > 30 THEN Bypass = 0
                END IF
        IF i$ = "p" OR i$ = "P" THEN
                CLS
                Plasm
                Altitude
                Smooth
                FOR x = 0 TO 319
                FOR y = 0 TO 199
                Copy x, y, 0
                NEXT: NEXT
                SOUND 1000, 1
                DO
                IF INKEY$ <> "" THEN EXIT DO
                MouseStatus
                IF Lbutton% OR Rbutton% THEN EXIT DO
                LOOP
                END IF
        IF i$ = "e" OR i$ = "E" THEN
                CLS
                FOR Xpos = 0 TO 319
                FOR Ypos = 0 TO 199
                Copy Xpos, Ypos, 3
                PSET (Xpos, Ypos), Colval1
                NEXT: NEXT
                SOUND 1000, 1
                DO
                IF INKEY$ <> "" THEN EXIT DO
                MouseStatus
                IF Lbutton% OR Rbutton% THEN EXIT DO
                LOOP
                END IF
        IF i$ = "f" OR i$ = "F" THEN Mirror 1
        IF i$ = "i" OR i$ = "I" THEN Mirror 0
        IF i$ = "r" OR i$ = "R" THEN
                CLS : Shading = 0
                Render
                END IF
        IF i$ = "l" OR i$ = "L" THEN AlphaPlasm
        IF i$ = "a" OR i$ = "A" THEN
                CLS : Shading = 1
                Render
                CLS
                Setpal
                PALETTE WaterLevel, 65536 * 45
                FOR x = 1 TO WaterLevel
                PALETTE x, 65536 * INT(x / (WaterLevel / 63))
                NEXT
                END IF
        IF i$ = CHR$(27) THEN SineText
        IF i$ = "o" OR i$ = "O" THEN
                LOCATE 10, 1: INPUT "Height Offset (-150-0):"; Hoffset
                IF Hoffset < -150 OR Hoffset > 0 THEN Hoffset = -70
                END IF
        GOTO 20
        END IF
LOOP

END SUB

SUB Mirror (Dir)

CLS
FOR Xpos = 0 TO 319
FOR Ypos = 0 TO 199
Copy Xpos, Ypos, 3
IF Dir = 1 THEN PSET (319 - Xpos, Ypos), Colval1
IF Dir = 0 THEN PSET (Xpos, 199 - Ypos), Colval1
NEXT: NEXT

FOR x = 0 TO 319
FOR y = 0 TO 199
Copy x, y, 0
NEXT: NEXT

SOUND 1000, 1
DO
IF INKEY$ <> "" THEN EXIT DO
MouseStatus
IF Lbutton% OR Rbutton% THEN EXIT DO
LOOP

END SUB

SUB MouseStatus

DEF SEG = VARSEG(Mouse$)
Mouse% = SADD(Mouse$)
CALL Absolute(3, bx%, CX%, DX%, Mouse%)
Lbutton% = ((bx% AND 1) <> 0)
Rbutton% = ((bx% AND 2) <> 0)
Xmouse% = CX%
Ymouse% = DX%

END SUB

SUB Plasm

stp = 5
FOR x = 0 TO 319 STEP stp
FOR y = 0 TO 199 STEP stp
LINE (x, y)-(x + stp - 1, y + stp - 1), RND * 255, BF
NEXT: NEXT

FOR stp = MtSize TO 1 STEP -1
FOR x = stp TO 319 - stp STEP stp
FOR y = stp TO 199 - stp STEP stp
LINE (x, y)-(x + stp - 1, y + stp - 1), (POINT(x + stp, y) + POINT(x, y + stp) + POINT(x - stp, y) + POINT(x, y - stp)) / 4, BF
NEXT: NEXT: NEXT

FOR x = 5 TO 314
FOR y = 0 TO 10
PSET (x, y), POINT(x, 21 - y)
PSET (x, y + 189), POINT(x, 188 - y)
NEXT: NEXT

FOR y = 0 TO 199
FOR x = 0 TO 10
PSET (x, y), POINT(21 - x, y)
PSET (x + 309, y), POINT(308 - x, y)
NEXT: NEXT

END SUB

SUB Render

IF Shading = 1 THEN
        FOR pp = 0 TO 255
        PALETTE pp / 255 * 200, INT(pp / 4) + INT(pp / 4) * 256 + INT(pp / 4) * 65536
        NEXT
        END IF

IF Bypass = 0 THEN
        FOR y = 0 TO 199
        FOR x = 0 TO 319
        Copy x, y, 3
        IF Shading = 1 THEN
                Col = y
                ELSE Col = Colval1
                END IF
        IF Colval1 > WaterLevel AND 100 + 2 * Contrast + y / 2 - Colval2 / Scale > 100 + y / 2 - WaterLevel / Scale THEN
                LINE (160 + (x - 160) * (y / 400 + .5), 100 + y / 2 - Colval1 / Scale + Yoffset)-(160 + (x - 160) * (y / 400 + .5), 100 + y / 2 - WaterLevel / Scale + Yoffset), Col
                ELSE
                IF Colval1 > WaterLevel THEN LINE (160 + (x - 160) * (y / 400 + .5), 100 + y / 2 - Colval1 / Scale + Yoffset)-(160 + (x - 160) * (y / 400 + .5), 100 + 2 * Contrast + y / 2 - Colval2 / Scale + Yoffset), Col
                IF Colval1 <= WaterLevel AND Colval1 > 0 THEN PSET (160 + (x - 160) * (y / 400 + .5), 100 + y / 2 - WaterLevel / Scale + Yoffset), Col
                END IF
        NEXT: NEXT
        END IF

IF Bypass <> 0 THEN
        FOR y = 0 TO 199 STEP Bypass + 1
        FOR x = 0 TO 319 STEP Bypass + 1
        Copy x, y, 3
        IF Shading = 1 THEN
                Col = y
                ELSE Col = Colval1
                END IF
        IF Colval1 > WaterLevel THEN PSET (160 + (x - 160) * (y / 400 + .5), 100 + y / 2 - Colval1 / Scale + Yoffset), Col
        IF Colval1 <= WaterLevel AND Colval1 > 0 THEN PSET (160 + (x - 160) * (y / 400 + .5), 100 + y / 2 - WaterLevel / Scale + Yoffset), Col
        NEXT: NEXT
        END IF

IF Shading = 0 THEN
        FOR Xpos = 0 TO 63
        FOR Ypos = 0 TO 39
        Copy Xpos, Ypos, 1
        NEXT: NEXT
        SOUND 1000, 1
        DO
        IF INKEY$ <> "" THEN EXIT DO
        MouseStatus
        IF Lbutton% OR Rbutton% THEN EXIT DO
        LOOP
        ELSE
        SOUND 1000, 1
        DO: LOOP UNTIL INKEY$ <> ""
        END IF

END SUB

SUB Setpal

FOR pal = 0 TO 63
PALETTE pal, 256 * 32 + pal
PALETTE pal + 64, 256 * 32 + 63 - INT(pal / 2)
PALETTE pal + 128, 256 * (32 - INT(pal / 2)) + 32 - INT(pal / 2) + 65536 * INT(pal / 4)
PALETTE pal + 192, pal + 256 * pal + 65536 * INT(16 + pal * 3 / 4)
NEXT

PALETTE 0, 65536 * 27

END SUB

SUB SineText

LINE (100, 80)-(220, 105), 0, BF
LOCATE 12, 19: PRINT "Sure?"
FOR x = 0 TO 110
PSET (105 + x, 83), WaterLevel + 1 + (x / 110 * (255 - WaterLevel))
PSET (105 + x, 85), 256 - (x / 110 * (255 - WaterLevel))
PSET (105 + x, 98), WaterLevel + 1 + (x / 110 * (255 - WaterLevel))
PSET (105 + x, 100), 256 - (x / 110 * (255 - WaterLevel))
NEXT

i$ = ""
DO
i$ = INKEY$
LOOP UNTIL i$ <> ""
IF i$ <> CHR$(27) AND i$ <> "y" AND i$ <> "Y" THEN GOTO 10

FOR x = 0 TO 159 STEP .1
LINE (x, x / 159 * 99)-(319 - x, 199 - x / 159 * 99), 0, B
NEXT

PALETTE 1, 0

Square = 1 + INT(RND * 9)
CLS
COLOR 1: PRINT "mylemans"

DIM y0(62): DIM y1(62): DIM y2(62): DIM y3(62)
DIM y4(62): DIM y5(62): DIM y6(62): DIM y7(62)

FOR x = 0 TO 61
y0(x) = POINT(x, 0): y1(x) = POINT(x, 1): y2(x) = POINT(x, 2): y3(x) = POINT(x, 3): y4(x) = POINT(x, 4): y5(x) = POINT(x, 5): y6(x) = POINT(x, 6): y7(x) = POINT(x, 7)
NEXT

CLS

PALETTE 2, 65536 * 32

COLOR 2: LOCATE 7, 17: PRINT "coded by"
LOCATE 23, 6: PRINT "http://members.xoom.com/Myleman"
LOCATE 24, 11: PRINT " mylemans@yahoo.com"

FOR x = 0 TO 63
PALETTE 2, x + 65536 * INT(32 + x / 2)
NEXT

DO
FOR Sine = 0 TO 6.283 STEP .4 / 10
FOR x = 0 TO 61
SineX = 20 * SIN(x / 10 + Sine) ^ Square
OldSineX = 20 * SIN(x / 10 + OldSine) ^ Square
IF y0(x) = 1 THEN PSET (70 + x * 3, 90 + OldSineX), 0
IF y0(x) = 1 THEN PSET (70 + x * 3, 90 + SineX), 2
IF y1(x) = 1 THEN PSET (70 + x * 3, 93 + OldSineX), 0
IF y1(x) = 1 THEN PSET (70 + x * 3, 93 + SineX), 2
IF y2(x) = 1 THEN PSET (70 + x * 3, 96 + OldSineX), 0
IF y2(x) = 1 THEN PSET (70 + x * 3, 96 + SineX), 2
IF y3(x) = 1 THEN PSET (70 + x * 3, 99 + OldSineX), 0
IF y3(x) = 1 THEN PSET (70 + x * 3, 99 + SineX), 2
IF y4(x) = 1 THEN PSET (70 + x * 3, 102 + OldSineX), 0
IF y4(x) = 1 THEN PSET (70 + x * 3, 102 + SineX), 2
IF y5(x) = 1 THEN PSET (70 + x * 3, 105 + OldSineX), 0
IF y5(x) = 1 THEN PSET (70 + x * 3, 105 + SineX), 2
IF y6(x) = 1 THEN PSET (70 + x * 3, 108 + OldSineX), 0
IF y6(x) = 1 THEN PSET (70 + x * 3, 108 + SineX), 2
IF y7(x) = 1 THEN PSET (70 + x * 3, 111 + OldSineX), 0
IF y7(x) = 1 THEN PSET (70 + x * 3, 111 + SineX), 2
IF INKEY$ <> "" THEN
FOR p = 63 TO 0 STEP -1
PALETTE 2, p + 65536 * p
PALETTE 0, 65536 * INT(p / 2)
NEXT
END
END IF
NEXT
OldSine = Sine
NEXT
LOOP
10

END SUB

SUB Smooth

FOR cnt = 1 TO Smoothing
FOR x = 1 TO 318
FOR y = 1 TO 198
PSET (x, y), (POINT(x - 1, y) + POINT(x, y - 1) + POINT(x, y + 1) + POINT(x + 1, y)) / 4
NEXT: NEXT: NEXT

END SUB

