DIM a$(37)        ' Let's you have up to 37 a$'s
DIM brick(100)    ' saves memory for the 10 by 10 brick
SCREEN 12
CLS : COLOR 1
x = 10: y = 6     ' starting coordinates

' Notice below that a$(#) starts at 11 and ends at 27

a$(11) = "ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo          "
a$(12) = "o                    o                                          o          "
a$(13) = "o o          o       o oooooooooooooooooooooooo ooooooooooooooooo          "
a$(14) = "o o          o                                                  o          "
a$(15) = "o o          oooooooooooooooooooooooo ooooooooo ooooooooooooooo o          "
a$(16) = "o o          o          o   o   o   o   o   o o o             o o          "
a$(17) = "o o          o ooo    o   o   o   o   o   o   o o o         o o o          "
a$(18) = "o o          o o o  ooooooooooooooooooooooooooo o o         o o o          "
a$(19) = "o oooooooooo o o o                            o o ooooooooooo o o          "
a$(20) = "o o        o o o oooo        ooooooooooooo    o                 o          "
a$(21) = "o oooooo   o o o      o      ooooooooooooo    ooooooooooooooooooo          "
a$(22) = "o o                   o                                         o          "
a$(23) = "o o oooooooooooooo    o    oooooooooooooooooooooooooooooooooooooo          "
a$(24) = "o o           o       o    o                                    o          "
a$(25) = "o ooooooooooo ooooooooo    oooooooooooooooooooooooo             o          "
a$(26) = "o                                                               o          "
a$(27) = "ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo          "

LINE (100, 100)-(220, 220), 4, B  ' Draws a red box
LINE (300, 70)-(420, 250), 1, B   ' draws a blue box
FOR r = 1 TO 10                ' this adds 10 empty a$'s before a$(11)
a$(r) = "                                                                                                       "
                               '  and after a$(27) so you can display empty                                                    "
a$(r + 27) = "                                                                                                                             "
                               ' space past the outer most walls                                                     
NEXT r
FOR r = 11 TO 27               ' this adds space infront of each a$ for the
a$(r) = "          " + a$(r)   ' same reason as above, I didn't do this when
NEXT r                         ' I drew the a$ map so I could see it all
                               ' but notice there ARE 10 spaces at the ends


LOCATE 1, 5: PRINT " <---- Press SPACE BAR to change"
GOSUB 1000       ' Jumps down to where I draw and get the brick
GOTO 20          ' Jumps past the beginning so it draws everything one
10 REM           ' time, or else the boxes would be empty until you hit a key

m$ = INKEY$: IF m$ = "" THEN 10   'waits for you to press a key............................
 FOR c = 1 TO 10: FOR r = 1 TO 10                                                 '  This draws a black square over all the bricks before it updates
 LINE (100 + 10 * r, 100 + 10 * c)-(100 + 10 * r + 10, 100 + 10 * c + 10), 0, BF  '  their position and redraws them...you could just draw one BIG
NEXT r, c                                                                         '  black square, but what if you want to draw somthing else in
                                                                                  '  each space?
IF m$ = " " THEN GOSUB 1000             ' if you hit the space bar it changes the brick
IF m$ = "8" AND y > 5 THEN y = y - 1    ' if you hit any of these keys,
IF m$ = "2" AND y < 22 THEN y = y + 1   ' the map position changes
IF m$ = "4" AND x > 5 THEN x = x - 1    '
IF m$ = "6" AND x < 70 THEN x = x + 1   '
20 REM------ cold start            ' this is where you jumped to to start.............
FOR c = 1 TO 10                                                                        ' this is the whole trick to mapping, it scans the
FOR r = 1 TO 10                                                                        ' a$'s the MIDdle starting at the x and y position
IF MID$(a$(y + c), x + r, 1) = "o" THEN PUT (100 + 10 * r, 100 + 10 * c), brick, PSET  ' and going 10 over then does the next a$ and goes 10 over etc..
LOCATE 5 + c, 40 + r: PRINT MID$(a$(y + c), x + r, 1)                                  ' everytime it finds an 'o' it draws a brick, you could have it
NEXT r                                                                                 ' draw somthing else if it finds something else
NEXT c                                                                                 '  The second part draws the actual a$ segments                                                               
GOTO 10

1000 REM                    '   this part draws a random brick design
FOR d = 1 TO 10             '   pretty straight forward...
FOR e = 1 TO 10             '
c = INT(RND(1) * 4) + 1     '
IF c = 1 THEN c = 0         '
IF c = 2 THEN c = 7         '
IF c = 3 THEN c = 8         '
IF c = 4 THEN c = 15        '
PSET (d, e), c              '
NEXT e: NEXT d              '

GET (1, 1)-(10, 10), brick   ' this stores whatever is on the screen in an
RETURN                       ' area from 1,1 to 10,10 into an array
                             ' called BRICK, then goes back to whereever
                             ' the programs was before it went here

