


pi = 3.14159                 ' This pi (pie) like on a calculator
                                  ' There are 2 pi's in a circle and
angle = 0 * pi                    ' 1 degree equals pi/180 which makes sense
                                  ' since there are 360 degrees in a circle
                                  ' To start, let the angle = 0 pi's

x = 300: y = 200             ' This is the center
ax = x + 20 * COS(angle)          ' all these points will rotate around
ay = y + 20 * SIN(angle)          ' your center.
bx = x + 20 * COS(angle + pi / 2) ' The TRICK is using SIN and COS
by = y + 20 * SIN(angle + pi / 2) ' COS always goes with x (left/right)
cx = x + 20 * COS(angle - pi / 2) ' SIN always goes with y (up/down)
cy = y + 20 * SIN(angle - pi / 2) ' 20 is the distance away from the center
                                  ' each point is at a different angle, but
                                  ' it is related to your initial angle
                                  ' (like angle plus or minus something)
                                  ' Changing your angle changes ALL of them

SCREEN 12                         ' Obviously.....
CLS                               '
10 REM ---------------            '
PSET (x, y), 0                    ' Clears all points
PSET (ax, ay), 0                  '
PSET (bx, by), 0                  '
PSET (cx, cy), 0                  '
                                  '
                                  '
angle = angle + (pi / 180)        ' Adds 1 degree to the angle
IF angle > 2 * pi THEN angle = 0  ' This is not necessary, but keeps things
                                  '  simple
ax = x + 20 * COS(angle)          ' All of this just updates each point
ay = y + 20 * SIN(angle)          '
bx = x + 20 * COS(angle + pi / 2) '
by = y + 20 * SIN(angle + pi / 2) '
cx = x + 20 * COS(angle - pi / 2) '
cy = y + 20 * SIN(angle - pi / 2) '
                                  '
PSET (x, y), 15                   ' this draws a dot at each new point
PSET (ax, ay), 5                  '
PSET (bx, by), 14                 '
PSET (cx, cy), 12                 '
FOR delay = 1 TO 100: NEXT delay  ' simple delay loop
                                  '

GOTO 10                           ' goes back to 10 and adds another degree
                                  
' now try connecting the points by drawing lines between them like                                 
' line (ax,ay)-(bx,by),4 would draw a red line between to of the points
' adding more points and connecting them in different ways lets you
' draw things like space ships or whatever that can turn in ANY direction
' alos, try moving x and y around etc....

