DECLARE SUB bigletter (Word$, Size%, Clr%, Style%, Position%)

SCREEN 12

'****(size, color, style, position)****

' 1 solid 2 squares 3 slant\ 4 slant/ 5 vertical lines 6 horizontal lines
'7 crosses 8 Xs 9 outline 10 spider web 11 bubbles 12 circles 13 shadow
'14 separated squares 15 building 16 stars

bigletter "Bigfoot", 4, 4, 9, 50
bigletter "Is", 5, 4, 10, 150
bigletter "In The", 6, 1, 12, 250
bigletter "House!!!", 7, 15, 15, 350

DEFINT A-Z
SUB bigletter (Word$, Size, Clr, Style, Position)
COLOR 15
   DIM Box(-1 TO 7, -1 TO 15)
   Wordlength = LEN(Word$) * Size * 8
   WordHeight = Size * 16
   WordCenter = 320 - (Wordlength / 2)
   PALETTE 15, 0
   FOR Letter = 1 TO LEN(Word$)
     LOCATE 1, 1
     PRINT MID$(Word$, Letter, 1)
     FOR x = 0 TO 7
       FOR y = 0 TO 15
        Box(x, y) = POINT(x, y)
       NEXT y
     NEXT x
     FOR x = 0 TO 7
       Left = WordCenter + (x * Size)
       Right = Left + Size
       lr = (Left + Right) \ 2
       FOR y = 0 TO 15
         Up = Position + (y * Size)
         Down = Up + Size
         UD = (Up + Down) \ 2
         IF Box(x, y) THEN
           SELECT CASE Style
              CASE 1
                'solid
                LINE (Left, Up)-(Right, Down), Clr, BF
              CASE 2
                'squares
                 LINE (Left, Up)-(Right, Down), Clr, B
              CASE 3
                'slant (\)
                 LINE (Left, Up)-(Right, Down), Clr
              CASE 4
                'slant (/)
                LINE (Right, Up)-(Left, Down), Clr
              CASE 5
                'Vertical Lines
                LINE (lr, Up)-(lr, Down), Clr
              CASE 6
                'Horizontal Lines
                LINE (Left, UD)-(Right, UD), Clr
              CASE 7
                'Crosses
                LINE (lr, Up)-(lr, Down), Clr
                LINE (Left, UD)-(Right, UD), Clr
              CASE 8
                'X's
                 LINE (Left, Up)-(Right, Down), Clr
                 LINE (Right, Up)-(Left, Down), Clr
              CASE 9
                'outline
                IF Box(x - 1, y) = 0 THEN LINE (Left, Up)-(Left, Down), Clr
                IF Box(x + 1, y) = 0 THEN LINE (Right, Up)-(Right, Down), Clr
                IF Box(x, y - 1) = 0 THEN LINE (Left, Up)-(Right, Up), Clr
                IF Box(x, y + 1) = 0 THEN LINE (Left, Down)-(Right, Down), Clr
              CASE 10
               'Spider Web
                IF Box(x - 1, y) = 0 THEN LINE (lr, UD)-(Left, UD), Clr
                IF Box(x + 1, y) = 0 THEN LINE (lr, UD)-(Right, UD), Clr
                IF Box(x, y - 1) = 0 THEN LINE (lr, UD)-(lr, Up), Clr
                IF Box(x, y + 1) = 0 THEN LINE (lr, UD)-(lr, Down), Clr
                IF Box(x - 1, y - 1) = 0 THEN LINE (lr, UD)-(Left, Up), Clr
                IF Box(x + 1, y - 1) = 0 THEN LINE (lr, UD)-(Right, Up), Clr
                IF Box(x - 1, y + 1) = 0 THEN LINE (lr, UD)-(Left, Down), Clr
                IF Box(x + 1, y + 1) = 0 THEN LINE (lr, UD)-(Right, Down), Clr
              CASE 11
                'Bubbles
                CIRCLE (lr, UD), Size \ 2, Clr
              CASE 12
                'Circles
                CIRCLE (lr, UD), Size \ 2, Clr
                PAINT STEP(0, 0), Clr
              CASE 13
                'Shadow
                IF Box(x + 1, y) = 0 THEN LINE (Right, Up)-(Right, Down), Clr
                IF Box(x, y + 1) = 0 THEN LINE (Left, Down)-(Right, Down), Clr
                IF Box(x + 1, y + 1) = 0 THEN PSET (Right, Down), Clr
              CASE 14
                'Seperated squares
                LINE (Left + 1, Up + 1)-(Right - 1, Down - 1), Clr, BF
              CASE 15
                'building
                LINE (Left, Down)-(lr, Up), Clr
                LINE STEP(0, 0)-(Right, Down), Clr
                LINE STEP(0, 0)-(Left, Down), Clr
                LINE (Left, Up)-(Right, Up), Clr
              CASE 16
                'STARS
                LINE (lr, Up)-(lr, Down), Clr
                LINE (Left, UD)-(Right, UD), Clr
                LINE (Left, Up)-(Right, Down), Clr
                LINE (Right, Up)-(Left, Down), Clr
              END SELECT
           END IF
         NEXT y
       NEXT x
     WordCenter = WordCenter + (Size * 8)
   NEXT Letter
   LOCATE 1, 1
   PRINT " "
   PALETTE
END SUB

