SUB PlayAdLib (comand$)
  STATIC tempo, length, music, octave

  IF comand$ = "{INIT}" THEN
    tempo = 120
    length = 4
    music = 7 / 8
    octave = 4
    EXIT SUB
  END IF

  comand$ = UCASE$(comand$)
  FOR i% = 0 TO 224
    WriteReg i%, 0
  NEXT i%
  WriteReg &H20, &H1 
  WriteReg &H23, &H1 
  WriteReg &H40, &H1F
  WriteReg &H43, &H0 
  WriteReg &H60, &HE4
  WriteReg &H63, &HE4
  WriteReg &H80, &H9D
  WriteReg &H83, &H9D
 
  c% = 1
  max% = LEN(comand$)
  WHILE c% <= max%
    x$ = MID$(comand$, c%, 1): c% = c% + 1 
    IF INSTR("ABCDEFG", x$) <> 0 AND (c% <> max% AND INSTR("+#-", MID$(comand$, c%, 1))) THEN
      x$ = x$ + MID$(comand$, c%, 1): c% = c% + 1
      IF RIGHT$(x$, 1) = "+" THEN x$ = LEFT$(x$, 1) + "#"
      IF x$ = "D-" THEN x$ = "C#"
      IF x$ = "E-" THEN x$ = "D#"
      IF x$ = "G-" THEN x$ = "F#"   
      IF x$ = "A-" THEN x$ = "G#"
      IF x$ = "B-" THEN x$ = "A#"
    ELSEIF x$ = "O" THEN
      adj% = VAL(MID$(comand$, c%, 1)): c% = c% + 1
      IF adj% >= 0 AND adj% <= 6 THEN octave = adj%
    ELSEIF x$ = "<" AND octave > 0 THEN
      octave = octave - 1
    ELSEIF x$ = ">" AND octave < 6 THEN
      octave = octave + 1
    ELSEIF x$ = "L" THEN
      num$ = ""
      WHILE INSTR("0123456789", MID$(comand$, c%, 1))
        num$ = num$ + MID$(comand$, c%, 1): c% = c% + 1
      WEND
      IF VAL(LTRIM$(num$)) >= 1 AND VAL(LTRIM$(num$)) <= 64 THEN length = VAL(LTRIM$(num$))
    ELSEIF x$ = "P" THEN
      dotfac = 1
      num$ = ""
      WHILE INSTR("0123456789", MID$(comand$, c%, 1))
        num$ = num$ + MID$(comand$, c%, 1): c% = c% + 1
      WEND
      WHILE MID$(comand$, c%, 1) = "."
        dotfac = dotfac * 1.5: c% = c% + 1
      WEND
      IF VAL(num$) >= 1 AND VAL(num$) <= 64 THEN
        start! = TIMER
        ender! = start! + (((1 / VAL(num$)) * dotfac) * ((tempo / 120) * 2) * music)
        DO
        LOOP UNTIL TIMER >= ender! 
      END IF
    ELSEIF x$ = "M" THEN
      next$ = MID$(comand$, c%, 1): c% = c% + 1
      x$ = x$ + next$
      IF x$ = "MN" THEN music = 7 / 8
      IF x$ = "MS" THEN music = 3 / 4
      IF x$ = "ML" THEN music = 1

    END IF
    IF INSTR("ABCDEFG", LEFT$(x$, 1)) THEN
      dotfac = 1
      WHILE MID$(comand$, c%, 1) = "."
        dotfac = dotfac * 1.5: c% = c% + 1
      WEND
      SELECT CASE x$
      CASE "C#"
        WriteReg &HA0, &H6B                 
        WriteReg &HB0, &H21 + 4 * octave    
      CASE "D"
        WriteReg &HA0, &H81
        WriteReg &HB0, &H21 + 4 * octave
      CASE "D#"
        WriteReg &HA0, &H98
        WriteReg &HB0, &H21 + 4 * octave
      CASE "E"
        WriteReg &HA0, &HB0
        WriteReg &HB0, &H21 + 4 * octave
      CASE "F"
        WriteReg &HA0, &HCA
        WriteReg &HB0, &H21 + 4 * octave
      CASE "F#"
        WriteReg &HA0, &HE5
        WriteReg &HB0, &H21 + 4 * octave
      CASE "G"
        WriteReg &HA0, &H2
        WriteReg &HB0, &H22 + 4 * octave
      CASE "G#"
        WriteReg &HA0, &H20
        WriteReg &HB0, &H22 + 4 * octave
      CASE "A"
        WriteReg &HA0, &H41
        WriteReg &HB0, &H22 + 4 * octave
      CASE "A#"
        WriteReg &HA0, &H63
        WriteReg &HB0, &H22 + 4 * octave
      CASE "B"
        WriteReg &HA0, &H87
        WriteReg &HB0, &H22 + 4 * octave
      CASE "C"
        WriteReg &HA0, &HAE
        WriteReg &HB0, &H22 + 4 * (octave - 1)
      END SELECT
      start! = TIMER
      ender! = start! + (((1 / length) * dotfac) * ((tempo / 120) * 2) * music)
      DO
      LOOP UNTIL TIMER >= ender!  
      WriteReg &HB0, 0
    END IF
  WEND
END SUB

SUB WriteReg (reg AS INTEGER, value AS INTEGER)
                    
  OUT &H388, reg    
                    
 
  FOR c% = 0 TO 5   
    a% = INP(&H388) 
  NEXT c%

  OUT &H389, value  
                    
                     
  FOR c% = 0 TO 34  
    a% = INP(&H388) 
  NEXT c%
END SUB