'This is the complete txtreng.bas file. I switched over to NetScape's
'USENET thingy, and it let me attach the whole file. Sorry about all the
'other pieces, it took me a while to think of trying NS.
'
'Anyway, this engine is slow, but it does add simple textures. I'm sure
'some intelligent person out there could speed it up, but that person
'sure as hell ain't me.
'
'I in no way am responsible for the engine itself; all I added was the
'textures(and I changed the background a bit, but, it's still mostly
'someone else's freeware program).
'
'Victor Woeltjen, "Pissant"
'
' note from Peter Cooper (peco@trenham.demon.co.uk)
' -  this is very very slow but it works
'    compile it for speed, you can download compiled version from my
'    web site
'
REM With modifications by Matt Bross.
REM I have left all the original comments in.
REM my comments are REMmed.
REM basicly all I did was elimanate all the floating point math.

DEFINT A-Z
DECLARE SUB CreateBackground ()

CONST UpArrow% = 72, DnArrow% = 80, LArrow% = 75, RArrow% = 77, Esc% = 1
CONST PI# = 22 / 7
REM ****************************INFO ARRAYS**********************************
REM $DYNAMIC
DIM Grid%(1 TO 12, 1 TO 12): REM Map
DIM STable(359 + 90) AS LONG: REM SIN table
DIM Textures(1 TO 15, 1 TO 4, 1 TO 30): REM Texture Data
DIM X1%(5)
REM ******************************VARIABLES**********************************
PX& = 9: PY& = 11    'the starting coordinates of the player's location
Stride = 3           'the distance covered in one "step" by the player
                     '   by pressing the up or down arrow keys
Heading% = 0         'the heading of the player (in degrees)
turn% = 20           'number of degrees of rotation produced by
                     '   pressing the right or left arrow keys

PX& = PX& * 1024: REM scale PX and PY to use fixed point math
PY& = PY& * 1024
REM ******************************LOAD INFO**********************************
FOR Y% = 1 TO 12: FOR X% = 1 TO 12
  READ Grid%(X%, Y%)
NEXT: NEXT

FOR TexturesL = 1 TO 15: FOR TexY% = 1 TO 30: FOR TexX% = 1 TO 4
    READ Textures(TexturesL, TexX%, TexY%)
NEXT: NEXT: NEXT

REM Make SIN table.  COS(x) = SIN(x + 90)
FOR A% = 0 TO 359 + 90: STable(A%) = (COS(A% * PI / 180) * 1024) \ 10: NEXT
REM ****************************INFO SCREEN**********************************
SCREEN 7, , 0, 0: RANDOMIZE TIMER
PRINT
PRINT
PRINT "            RAYCASTER DEMO"
PRINT
PRINT "      UP ARROW........Move Forward"
PRINT "      DOWN ARROW......Move Backward"
PRINT "      RIGHT ARROW.....Turn Right"
PRINT "      LEFT ARROW......Turn Left"
PRINT
PRINT
PRINT "            Please wait...";
REM ***************************CREATE BACKGROUND*****************************
SCREEN , , 2, 0: CLS
' Moon
CIRCLE (50, 30), 10, 8: PAINT (50, 30), 14, 8
CIRCLE (43, 29), 10, 0: PAINT (43, 29), 0, 0

' Clouds moved after moon so they would overlap it
FOR Cnt% = 1 TO 10
  X% = INT(RND * (320 - R% - R%))
  Y% = INT(RND * 80) + 10
  R% = INT(RND * 50)
  aspect! = RND / 10
  CIRCLE (X%, Y%), R%, 15, , , aspect!: PAINT (X%, Y%), 15
NEXT

 'Building (gray)
LINE (200, 20)-(220, 15), 8: LINE -(240, 20), 8: LINE -(240, 99), 8
LINE (200, 20)-(200, 99), 8: LINE -(240, 99), 8: PAINT (220, 50), 8
FOR Cnt% = 1 TO 20 ' Lights
  PSET (INT(RND * 38) + 201, INT(RND * 80) + 20), 14
NEXT
' Building (border)
LINE (200, 20)-(220, 15), 0: LINE -(240, 20), 0: LINE -(240, 99), 0
LINE (219, 15)-(219, 99), 0: LINE (200, 20)-(200, 99), 0

FOR Y% = 100 TO 199: FOR X% = 0 TO 319
  IF RND > .5 THEN PSET (X%, Y%), 8
NEXT: NEXT

SCREEN , , 0, 0
REM *****************************READY TO GO*********************************
LOCATE , 1
PRINT "        Press any key to begin...";
DO WHILE LEN(INKEY$): LOOP: DO UNTIL LEN(INKEY$): LOOP
REM ********************SET UP AND DRAW FIRST FRAME**************************
ViewPG% = 0: WorkPG% = 1: BG1% = 2
ReverseTurn% = 360 - turn%
SCREEN , , WorkPG%, ViewPG%
GOTO ComputeView

DEF SEG = 0
REM -------------------------->BEGIN MAIN LOOP<------------------------------
DO 'Main loop

REM *****************************FAST INKEY$*********************************
GetKey: DO: Keycode% = INP(&H60): LOOP UNTIL Keycode%
WHILE LEN(INKEY$): WEND

SELECT CASE Keycode%
  CASE LArrow: Heading% = (Heading% + turn%) MOD 360
  CASE RArrow: Heading% = (Heading% + ReverseTurn%) MOD 360
  CASE UpArrow
    NewPX& = PX& - (STable(Heading% + 90) * Stride)
    NewPY& = PY& - (STable(Heading%) * Stride)
    IF Grid%(NewPX& \ 1024, NewPY& \ 1024) = 0 THEN
      PX& = NewPX&: PY& = NewPY&
    ELSE 'tried to walk through a wall
      SOUND 80, 1: GOTO GetKey
    END IF
  CASE DnArrow
    NewPX& = PX& + (STable(Heading% + 90) * Stride)
    NewPY& = PY& + (STable(Heading%) * Stride)
    IF Grid%(NewPX& \ 1024, NewPY& \ 1024) = 0 THEN
      PX& = NewPX&: PY& = NewPY&
    ELSE 'tried to walk through a wall
      SOUND 80, 1: GOTO GetKey
    END IF
  CASE Esc: EXIT DO
  CASE ELSE: GOTO GetKey
  END SELECT
REM ****************************CASTS OFF RAYS*******************************
ComputeView:
PCOPY BG1%, WorkPG%
X1%(0) = 0: X1%(1) = 1: X1%(2) = 2
X1%(3) = 3: X1%(4) = 4: X1%(5) = 5

FOR A% = Heading% + 32 TO Heading% - 31 STEP -1
  Angle = A% MOD 360: IF Angle < 0 THEN Angle = Angle + 360
  StepX& = STable(Angle + 90): StepY& = STable(Angle)
  XX& = PX&: YY& = PY&
  L% = 0

  DO
    XX& = XX& - StepX&: YY& = YY& - StepY&
    L% = L% + 1
    K% = Grid%(XX& \ 1024, YY& \ 1024)
  LOOP UNTIL K%
REM **************************RENDERING PROCCESS*****************************
  DD% = 900 \ L%
  H% = DD% + DD%
  DT% = 100 - DD%
  YMoves = 0: YTemp& = 0: YLimit& = H% * 30&
  GoStep = H% \ 30: IF GoStep < 1 THEN GoStep = 1
  FOR Y = DT% TO DT% + H% STEP GoStep
    YMoves = YMoves + 1: IF YMoves > 30 THEN YMoves = 30: YTemp& = YLimit&
    YTemp& = YTemp& + H%
    YPlace1% = YTemp& \ 30 + DT%
    YPlace2% = YPlace1% - GoStep
      LINE (X1%(1), YPlace1%)-(X1%(1), YPlace2%), Textures(K%, 1, YMoves)
      LINE (X1%(2), YPlace1%)-(X1%(2), YPlace2%), Textures(K%, 2, YMoves)
      LINE (X1%(3), YPlace1%)-(X1%(3), YPlace2%), Textures(K%, 3, YMoves)
      LINE (X1%(4), YPlace1%)-(X1%(4), YPlace2%), Textures(K%, 4, YMoves)
      LINE (X1%(5), YPlace1%)-(X1%(5), YPlace2%), Textures(K%, 4, YMoves)
  NEXT
 
  X1%(0) = X1%(0) + 5: X1%(1) = X1%(0) + 1: X1%(2) = X1%(0) + 2
  X1%(3) = X1%(1) + 2: X1%(4) = X1%(2) + 2: X1%(5) = X1%(0) + 5
NEXT

SWAP WorkPG%, ViewPG%
SCREEN , , WorkPG%, ViewPG%

LOOP
REM -------------------------->END MAIN LOOP<--------------------------------
DEF SEG : SCREEN 0: WIDTH 80, 25: END
REM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%LEVEL DATA%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DATA  9,  1,  9,  1,  1,  1,  1,  1,  1,  1,  9,  9
DATA  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  9
DATA  9,  0,  2, 10,  0,  0,  0,  0,  0,  0,  0,  1
DATA  1,  0, 10,  2,  0,  0,  0,  0,  0,  0,  0,  9
DATA  9,  0,  0,  0,  0,  5,  0,  0,  0,  0,  0,  1
DATA  1,  0,  0,  0,  0,  4,  0,  0,  0,  0,  0,  9
DATA  9,  0,  0,  0,  0,  6,  0,  0,  0,  0,  0,  1
DATA  1,  0, 13,  0,  0,  4,  0,  0,  0, 12,  0,  9
DATA  9,  0,  5,  0,  0,  5,  0,  0,  0,  0,  0,  1
DATA  1,  0, 13,  0,  0,  0,  0,  0,  0, 12,  0,  9
DATA  9,  0,  5,  0,  0,  0,  0,  0,  0,  4,  0,  1
DATA  9,  9,  1,  9,  1,  9,  1,  9,  1,  9,  1,  9
REM %%%%%%%%%%%%%%%%%%%%%%%%%%%%TEXTURE DATA%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'Text. 1
DATA 0, 8, 0, 0
DATA 8, 7, 8, 0
DATA 7, 7, 7, 8
DATA 7, 7, 7, 8
DATA 8, 8, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 8, 8, 8
DATA 7, 7, 7, 7
DATA 8, 8, 8, 8
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 0
DATA 8, 7, 8, 2
DATA 8, 2, 8, 2
DATA 2,10, 2, 2
DATA 2, 2,10, 2
DATA 2, 2, 2, 2
'Text. 2
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15,7,15
DATA  7, 7, 7, 0
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 3
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7, 5, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7, 5, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 4
DATA  4, 4, 4, 4
DATA  4, 8, 4, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  4, 8, 4, 8
DATA  4, 4, 4, 4
'Text. 5
DATA  4, 8, 4, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 4, 8, 4
'Text. 6
DATA  4, 6, 4, 6
DATA  4, 4, 4, 4
DATA  8, 4, 8, 4
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  4, 7, 4, 7
DATA  4, 4, 4, 4
DATA  4, 6, 4, 6
'Text. 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 8
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 9
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 10
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 11
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 12
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 13
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text. 14
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
'Text.15
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8
DATA  8, 7, 8, 7
DATA  7, 7, 7, 7
DATA  7,15, 7,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA 15,15,15,15
DATA  7,15, 7,15
DATA  7, 7, 7, 7
DATA  8, 7, 8, 7
DATA  8, 8, 8, 8
DATA  8, 8, 8, 8

